/*
 Tecnisa - Tecnologia em Informtica

 Nome: GERA_TRAB_PREV_PIRATA - 1070_FINSTP_GERA_TRAB_PREV_PIRATA.SQL

 Descrio:
 Grava os dados referentes ao relatrio de Fluxo de Caixa (Formulrio)

 Criao:
 02/07/2001 - Andr Rodrigo

 SET SERVEROUTPUT ON
 EXECUTE GERA_TRAB_PREV_PIRATA('9999', '0000000001', '01/05/2003', '05/05/2003', '01');
 COMMIT;

DBMS_OUTPUT.PUT_LINE(V_NRCOLUNA||'-'||C_DATA.DTDATA||'-'||V_IDATRASO);

'01' => 'Bancos'                      // {Padrao}
   '02' => 'Movimento de Crdito'
   '03' => 'Movimento de Dbito'
   '04' => 'Transferncia Bancria'
'10', 'Contas a Receber'
   '11' => 'Contas a Receber Baixadas'
   '12' => 'Contas a Receber'         // Especifico
'20', 'Contas a Pagar'
   '21' => 'Contas a Pagar Baixadas'
'30', 'Previso de Entradas'
'40', 'Previso de Sadas'
'50', 'Contas a Receber Previstas'
'60', 'Contas a Pagar Previstas'

*/

CREATE OR REPLACE PROCEDURE GERA_TRAB_PREV_PIRATA
   (P_CDFILIAL    IN TRAB_PREV.CDFILIPREV%TYPE,
    P_NRPREVISAO  IN TRAB_PREV.NRPREVISAO%TYPE,
    P_DTPERIINIC  IN DATE,
    P_DTPERIFINA  IN DATE,
    P_CDEMPRESA   IN VARCHAR2)

AS
   V_NRPAGINA    NUMBER;
   V_NRREGIENCA  NUMBER;
   V_NRREG_MIN   NUMBER;
   V_NRCOLUNA    NUMBER;
   V_TOTALDIA    NUMBER;
   V_CTSALDO     NUMBER;
   V_CTCONTA     NUMBER;
   V_TOTMOVIANT  NUMBER;
   V_IDATRASO    VARCHAR2(1);
   V_CENTCUST    VARCHAR2(20);
   V_ISEMPTY     VARCHAR2(1);

   CURSOR C_PERIODO IS
      SELECT DTDATA
      FROM DATA
      WHERE
         DTDATA BETWEEN P_DTPERIINIC AND P_DTPERIFINA;

   CURSOR C_BANCOS IS
      SELECT DISTINCT
         CC.CDEMPRESA, BC.CDBANCO, BC.NMBANCO
      FROM CONTCORR CC, BANCO BC
      WHERE (CC.CDBANCO  = BC.CDBANCO) AND
            (P_CDEMPRESA = 'T' OR INSTR(P_CDEMPRESA, CDEMPRESA) <> 0)
      ORDER BY CC.CDEMPRESA, BC.CDBANCO;

   CURSOR C_EMPRESA IS
      SELECT CDEMPRESA, NMEMPRESA
      FROM EMPRESA
      WHERE
         (P_CDEMPRESA = 'T' OR INSTR(P_CDEMPRESA, CDEMPRESA) <> 0)
      ORDER BY CDEMPRESA;

   CURSOR C_CLASSFINANC IS
      SELECT CDCLASSFINA, DSCLASSFINA
      FROM CLASSFINANC
      ORDER BY CDCLASSFINA;

BEGIN
   V_NRREGIENCA := 1;

   /* -------------------------------------------------------------*/
   /* --- GRAVA O VALOR DOS MOVIMENTOS DE CREDITOS  [GRUPO 02] ---
   /* ---          DUPLICATAS DESCONTADA      [OK]                     */
   /* -------------------------------------------------------------*/
   V_NRREGIENCA := V_NRREGIENCA + 1;
   FOR C_EMP IN C_EMPRESA LOOP
      FOR C_CLASS IN C_CLASSFINANC LOOP
         V_NRCOLUNA   := 1;
         V_NRPAGINA   := 1;

         SELECT COUNT(*) INTO V_CTCONTA
         FROM MOVCREDBANC
         WHERE
            CDTPCREDBANC = '04' AND
            DTMOVICRED BETWEEN P_DTPERIINIC AND P_DTPERIFINA AND
            CDCLASSFINA = C_CLASS.CDCLASSFINA AND
            CDEMPRESA   = C_EMP.CDEMPRESA;

         IF V_CTCONTA > 0 THEN
            FOR C_DATA IN C_PERIODO LOOP
               V_TOTALDIA := 0;
               SELECT SUM(VRMOVICRED) INTO V_TOTALDIA
               FROM MOVCREDBANC
               WHERE
                  CDTPCREDBANC = '04' AND
                  DTMOVICRED  = C_DATA.DTDATA       AND
                  CDCLASSFINA = C_CLASS.CDCLASSFINA AND
                  CDEMPRESA   = C_EMP.CDEMPRESA;

               IF V_TOTALDIA IS NULL THEN
                  V_TOTALDIA := 0;
               END IF;
               IF (V_NRCOLUNA > 1) THEN
                  ALTERA_TRAB_PREV(P_CDFILIAL, P_NRPREVISAO,  LPAD(TO_CHAR(V_NRREGIENCA), 10, '0'),
                                   V_NRCOLUNA, C_DATA.DTDATA, V_TOTALDIA);
               ELSE
                  INSERT INTO TRAB_PREV(
                     CDFILIPREV,   NRPREVISAO, NRREGIPREV,
                     NRPAGIPREV,   CDGRUPPREV, CDEMPRPREV,
                     CDITEMPREV,   DSITEMPREV,
                     DTDIA01PREV,  VRDIA01PREV,
                     DTINIPERPREV, DTFINPERPREV)
                  VALUES(
                     P_CDFILIAL,          P_NRPREVISAO, LPAD(TO_CHAR(V_NRREGIENCA), 10, '0'),
                     V_NRPAGINA,          '02',         C_EMP.CDEMPRESA,
                     C_CLASS.CDCLASSFINA, C_CLASS.DSCLASSFINA,
                     C_DATA.DTDATA,       V_TOTALDIA,
                     P_DTPERIINIC,        P_DTPERIFINA);
               END IF;

               /* CONTROLA A COLUNA E A PGINA DO RELATRIO */
               V_NRCOLUNA   := V_NRCOLUNA + 1;
               IF V_NRCOLUNA > 6 THEN
                  V_NRPAGINA   := V_NRPAGINA + 1;
                  V_NRCOLUNA   := 1;
                  V_NRREGIENCA := V_NRREGIENCA + 1;
               END IF;
            END LOOP;
            V_NRREGIENCA := V_NRREGIENCA + 1;
         END IF;
      END LOOP;
   END LOOP;


   /* -------------------------------------------------------------*/
   /* -- GRAVA O VALOR DAS CONTAS A RECEBER (ABERTAS) [GRUPO 03] - */
   /*               DUPLICATAS SIMPLES   [OK]                          */
   /* -------------------------------------------------------------*/
   FOR C_EMP IN C_EMPRESA LOOP
      FOR C_CLASS IN C_CLASSFINANC LOOP
         V_NRPAGINA   := 1;

         /* GRAVA OS VALORES DAS CONTAS A RECEBER EM ATRASO */
         SELECT SUM(VRATUAREC) INTO V_TOTALDIA
         FROM
            (SELECT SUM(CR.VRATUAREC) VRATUAREC
             FROM
                NOTAFISCAL   NF, CONTARECEBER CR, BOLETRECEBER BO
             WHERE
                CR.CDEMPRESA    = C_EMP.CDEMPRESA      AND
                CR.CDCLASSFINA  = C_CLASS.CDCLASSFINA  AND
                CR.DTMOVFLUXO <= P_DTPERIINIC - 1    AND
                NF.CDFILIAL     = CR.CDFILIAL          AND
                NF.NRLANCTONF   = CR.NRLANCTONF        AND
                NF.IDSTATUS  IN ('A', 'E')             AND
                CR.CDFILIBOLREC = BO.CDFILIAL          AND
                CR.NRLANBOLREC  = BO.NRLANBOLREC
                AND (NOT CR.IDSTATREC IN ('B', 'C'))
                AND (BO.CDCARTCOBBOL IN ('01', '11', '09', '15'))
             UNION
             SELECT SUM(MJ.VRFXAJBOLREC) VRATUAREC
             FROM TIPOAJRECEBER TA, MOVFXAJBOLR MJ, BOLETRECEBER BO
             WHERE
                MJ.CDEMPRESA   = C_EMP.CDEMPRESA      AND
                MJ.CDCLASSFINA = C_CLASS.CDCLASSFINA  AND
                MJ.DTMOVFLUXO  <= P_DTPERIINIC - 1    AND
                MJ.CDAJUCTREC  = TA.CDAJUCTREC        AND
                TA.IDAJUCTREC  = 'A'                  AND
                MJ.CDFILIBOLREC = BO.CDFILIAL         AND
                MJ.NRLANBOLREC  = BO.NRLANBOLREC
                AND (NOT BO.IDSTATBREC IN ('B', 'C'))
                AND (BO.CDCARTCOBBOL IN ('01', '11', '09', '15'))
             UNION
             SELECT SUM(MJ.VRFXAJBOLREC * -1) VRATUAREC
             FROM TIPOAJRECEBER TA, MOVFXAJBOLR MJ, BOLETRECEBER BO
             WHERE
                MJ.CDEMPRESA   = C_EMP.CDEMPRESA      AND
                MJ.CDCLASSFINA = C_CLASS.CDCLASSFINA  AND
                MJ.DTMOVFLUXO  <= P_DTPERIINIC - 1    AND
                MJ.CDAJUCTREC  = TA.CDAJUCTREC        AND
                TA.IDAJUCTREC  = 'D'                  AND
                MJ.CDFILIBOLREC = BO.CDFILIAL         AND
                MJ.NRLANBOLREC  = BO.NRLANBOLREC
                AND (NOT BO.IDSTATBREC IN ('B', 'C'))
                AND (BO.CDCARTCOBBOL IN ('01', '11', '09', '15')));
         V_IDATRASO := 'N';
         IF V_TOTALDIA > 0 THEN
            INSERT INTO TRAB_PREV(
               CDFILIPREV,   NRPREVISAO, NRREGIPREV,
               NRPAGIPREV,   CDGRUPPREV, CDEMPRPREV,
               CDITEMPREV,   DSITEMPREV, VRATRASOPREV,
               DTINIPERPREV, DTFINPERPREV)
            VALUES(
               P_CDFILIAL,          P_NRPREVISAO,        LPAD(TO_CHAR(V_NRREGIENCA), 10, '0'),
               V_NRPAGINA,          '03',                C_EMP.CDEMPRESA,
               C_CLASS.CDCLASSFINA, C_CLASS.DSCLASSFINA, V_TOTALDIA,
               P_DTPERIINIC,        P_DTPERIFINA);
               V_IDATRASO := 'S';
         END IF;

         SELECT COUNT(*) INTO V_CTCONTA
         FROM
            NOTAFISCAL   NF,
            CONTARECEBER CR,
            BOLETRECEBER BO
         WHERE
            CR.CDEMPRESA    = C_EMP.CDEMPRESA      AND
            CR.CDCLASSFINA  = C_CLASS.CDCLASSFINA  AND
            CR.DTMOVFLUXO BETWEEN P_DTPERIINIC AND P_DTPERIFINA AND
            NF.CDFILIAL     = CR.CDFILIAL          AND
            NF.NRLANCTONF   = CR.NRLANCTONF        AND
            NF.IDSTATUS  IN ('A', 'E')             AND
            CR.CDFILIBOLREC = BO.CDFILIAL          AND
            CR.NRLANBOLREC  = BO.NRLANBOLREC
            AND (CR.IDSTATREC <> 'C')
            AND (BO.CDCARTCOBBOL IN ('01', '11', '09', '15'));

         IF (V_IDATRASO = 'S') OR (V_CTCONTA > 0) THEN
            /* GRAVA OS VALORES DAS CONTAS A RECEBER */
            V_NRCOLUNA := 1;
            FOR C_DATA IN C_PERIODO LOOP

               V_TOTALDIA := 0;
               FOR C_CNTREC IN (
                  SELECT SUM(CR.VRATUAREC) VRATUAREC
                  FROM
                     NOTAFISCAL   NF,
                     CONTARECEBER CR,
                     BOLETRECEBER BO
                  WHERE
                     CR.CDEMPRESA    = C_EMP.CDEMPRESA      AND
                     CR.CDCLASSFINA  = C_CLASS.CDCLASSFINA  AND
                     CR.DTMOVFLUXO = C_DATA.DTDATA        AND
                     NF.CDFILIAL     = CR.CDFILIAL          AND
                     NF.NRLANCTONF   = CR.NRLANCTONF        AND
                     NF.IDSTATUS  IN ('A', 'E')             AND
                     CR.CDFILIBOLREC = BO.CDFILIAL          AND
                     CR.NRLANBOLREC  = BO.NRLANBOLREC
                     AND (CR.IDSTATREC <> 'C')
                     AND (BO.CDCARTCOBBOL IN ('01', '11', '09', '15'))
                  UNION
                  SELECT SUM(MJ.VRFXAJBOLREC) VRATUAREC
                  FROM TIPOAJRECEBER TA, MOVFXAJBOLR MJ, BOLETRECEBER BO
                  WHERE
                     MJ.CDEMPRESA   = C_EMP.CDEMPRESA      AND
                     MJ.CDCLASSFINA = C_CLASS.CDCLASSFINA  AND
                     MJ.DTMOVFLUXO  = C_DATA.DTDATA        AND
                     MJ.CDAJUCTREC  = TA.CDAJUCTREC        AND
                     TA.IDAJUCTREC  = 'A'                  AND
                     MJ.CDFILIBOLREC = BO.CDFILIAL         AND
                     MJ.NRLANBOLREC  = BO.NRLANBOLREC
                     AND (BO.IDSTATBREC <> 'C')
                     AND (BO.CDCARTCOBBOL IN ('01', '11', '09', '15'))
                  UNION
                  SELECT SUM(MJ.VRFXAJBOLREC * -1) VRATUAREC
                  FROM TIPOAJRECEBER TA, MOVFXAJBOLR MJ, BOLETRECEBER BO
                  WHERE
                     MJ.CDEMPRESA   = C_EMP.CDEMPRESA      AND
                     MJ.CDCLASSFINA = C_CLASS.CDCLASSFINA  AND
                     MJ.DTMOVFLUXO  = C_DATA.DTDATA        AND
                     MJ.CDAJUCTREC  = TA.CDAJUCTREC        AND
                     TA.IDAJUCTREC  = 'D'                  AND
                     MJ.CDFILIBOLREC = BO.CDFILIAL         AND
                     MJ.NRLANBOLREC  = BO.NRLANBOLREC
                     AND (BO.IDSTATBREC <> 'C')
                     AND (BO.CDCARTCOBBOL IN ('01', '11', '09', '15'))) LOOP

                  IF C_CNTREC.VRATUAREC IS NULL THEN
                     V_TOTALDIA := V_TOTALDIA + 0;
                  ELSE
                     V_TOTALDIA := V_TOTALDIA + C_CNTREC.VRATUAREC;
                  END IF;
               END LOOP;

               IF (V_NRCOLUNA > 1) OR (V_IDATRASO = 'S') THEN
                  ALTERA_TRAB_PREV(P_CDFILIAL, P_NRPREVISAO,  LPAD(TO_CHAR(V_NRREGIENCA), 10, '0'),
                                   V_NRCOLUNA, C_DATA.DTDATA, V_TOTALDIA);
               ELSE
                  INSERT INTO TRAB_PREV(
                     CDFILIPREV,   NRPREVISAO, NRREGIPREV,
                     NRPAGIPREV,   CDGRUPPREV, CDEMPRPREV,
                     CDITEMPREV,   DSITEMPREV,
                     DTDIA01PREV,  VRDIA01PREV,
                     DTINIPERPREV, DTFINPERPREV)
                  VALUES(
                     P_CDFILIAL,          P_NRPREVISAO, LPAD(TO_CHAR(V_NRREGIENCA), 10, '0'),
                     V_NRPAGINA,          '03',         C_EMP.CDEMPRESA,
                     C_CLASS.CDCLASSFINA, C_CLASS.DSCLASSFINA,
                     C_DATA.DTDATA,       V_TOTALDIA,
                     P_DTPERIINIC,        P_DTPERIFINA);
               END IF;

               /* CONTROLA A COLUNA E A PGINA DO RELATRIO */
               V_NRCOLUNA   := V_NRCOLUNA + 1;
               IF V_NRCOLUNA > 6 THEN
                  V_NRPAGINA   := V_NRPAGINA + 1;
                  V_NRCOLUNA   := 1;
                  V_NRREGIENCA := V_NRREGIENCA + 1;
                  V_IDATRASO   := 'N';
               END IF;
            END LOOP;
            V_NRREGIENCA := V_NRREGIENCA + 1;
         END IF;
      END LOOP;
   END LOOP;

   /* -------------------------------------------------------------*/
   /* -- GRAVA O VALOR DAS CONTAS A RECEBER (ABERTAS) [GRUPO 04] - */
   /*                  VALORES S/ VINCULO BANCARIO   [OK]              */
   /* -------------------------------------------------------------*/
   FOR C_EMP IN C_EMPRESA LOOP
      FOR C_CLASS IN C_CLASSFINANC LOOP
         V_NRPAGINA   := 1;

         /* GRAVA OS VALORES DAS CONTAS A RECEBER EM ATRASO */
         SELECT SUM(VRATUAREC) INTO V_TOTALDIA
         FROM
            (SELECT SUM(CR.VRATUAREC) VRATUAREC
             FROM
                NOTAFISCAL   NF, CONTARECEBER CR, BOLETRECEBER BO
             WHERE
                CR.CDEMPRESA    = C_EMP.CDEMPRESA      AND
                CR.CDCLASSFINA  = C_CLASS.CDCLASSFINA  AND
                CR.DTMOVFLUXO <= P_DTPERIINIC - 1    AND
                NF.CDFILIAL     = CR.CDFILIAL          AND
                NF.NRLANCTONF   = CR.NRLANCTONF        AND
                NF.IDSTATUS  IN ('A', 'E')             AND
                CR.CDFILIBOLREC = BO.CDFILIAL          AND
                CR.NRLANBOLREC  = BO.NRLANBOLREC
                AND (NOT CR.IDSTATREC IN ('B', 'C'))
                AND (NVL(BO.CDCARTCOBBOL, '1') = '1')
             UNION
             SELECT SUM(MJ.VRFXAJBOLREC) VRATUAREC
             FROM TIPOAJRECEBER TA, MOVFXAJBOLR MJ, BOLETRECEBER BO
             WHERE
                MJ.CDEMPRESA   = C_EMP.CDEMPRESA      AND
                MJ.CDCLASSFINA = C_CLASS.CDCLASSFINA  AND
                MJ.DTMOVFLUXO  <= P_DTPERIINIC - 1    AND
                MJ.CDAJUCTREC  = TA.CDAJUCTREC        AND
                TA.IDAJUCTREC  = 'A'                  AND
                MJ.CDFILIBOLREC = BO.CDFILIAL         AND
                MJ.NRLANBOLREC  = BO.NRLANBOLREC
                AND (NOT BO.IDSTATBREC IN ('B', 'C'))
                AND (NVL(BO.CDCARTCOBBOL, '1') = '1')
             UNION
             SELECT SUM(MJ.VRFXAJBOLREC * -1) VRATUAREC
             FROM TIPOAJRECEBER TA, MOVFXAJBOLR MJ, BOLETRECEBER BO
             WHERE
                MJ.CDEMPRESA   = C_EMP.CDEMPRESA      AND
                MJ.CDCLASSFINA = C_CLASS.CDCLASSFINA  AND
                MJ.DTMOVFLUXO  <= P_DTPERIINIC - 1    AND
                MJ.CDAJUCTREC  = TA.CDAJUCTREC        AND
                TA.IDAJUCTREC  = 'D'                  AND
                MJ.CDFILIBOLREC = BO.CDFILIAL         AND
                MJ.NRLANBOLREC  = BO.NRLANBOLREC
                AND (NOT BO.IDSTATBREC IN ('B', 'C'))
                AND (NVL(BO.CDCARTCOBBOL, '1') = '1'));
         V_IDATRASO := 'N';
         IF V_TOTALDIA > 0 THEN
            INSERT INTO TRAB_PREV(
               CDFILIPREV,   NRPREVISAO, NRREGIPREV,
               NRPAGIPREV,   CDGRUPPREV, CDEMPRPREV,
               CDITEMPREV,   DSITEMPREV, VRATRASOPREV,
               DTINIPERPREV, DTFINPERPREV)
            VALUES(
               P_CDFILIAL,          P_NRPREVISAO,        LPAD(TO_CHAR(V_NRREGIENCA), 10, '0'),
               V_NRPAGINA,          '04',                C_EMP.CDEMPRESA,
               C_CLASS.CDCLASSFINA, C_CLASS.DSCLASSFINA, V_TOTALDIA,
               P_DTPERIINIC,        P_DTPERIFINA);
               V_IDATRASO := 'S';
         END IF;
            /*MATAR*/
         SELECT COUNT(*) INTO V_CTCONTA
         FROM
            NOTAFISCAL   NF,
            CONTARECEBER CR,
            BOLETRECEBER BO
         WHERE
            CR.CDEMPRESA    = C_EMP.CDEMPRESA      AND
            CR.CDCLASSFINA  = C_CLASS.CDCLASSFINA  AND
            CR.DTMOVFLUXO BETWEEN P_DTPERIINIC AND P_DTPERIFINA AND
            NF.CDFILIAL     = CR.CDFILIAL          AND
            NF.NRLANCTONF   = CR.NRLANCTONF        AND
            NF.IDSTATUS  IN ('A', 'E')             AND
            CR.CDFILIBOLREC = BO.CDFILIAL          AND
            CR.NRLANBOLREC  = BO.NRLANBOLREC
            AND (NOT CR.IDSTATREC IN ('B', 'C'))
            AND IDCARTCOBREC = '1'
            AND (NVL(BO.CDCARTCOBBOL, '1') = '1');

         IF (V_IDATRASO = 'S') OR (V_CTCONTA > 0) THEN
            /* GRAVA OS VALORES DAS CONTAS A RECEBER */
            V_NRCOLUNA := 1;
            FOR C_DATA IN C_PERIODO LOOP

               V_TOTALDIA := 0;
               FOR C_CNTREC IN (
                  SELECT SUM(CR.VRATUAREC) VRATUAREC
                  FROM
                     NOTAFISCAL   NF,
                     CONTARECEBER CR,
                     BOLETRECEBER BO
                  WHERE
                     CR.CDEMPRESA    = C_EMP.CDEMPRESA      AND
                     CR.CDCLASSFINA  = C_CLASS.CDCLASSFINA  AND
                     CR.DTMOVFLUXO = C_DATA.DTDATA        AND
                     NF.CDFILIAL     = CR.CDFILIAL          AND
                     NF.NRLANCTONF   = CR.NRLANCTONF        AND
                     NF.IDSTATUS  IN ('A', 'E')             AND
                     CR.CDFILIBOLREC = BO.CDFILIAL          AND
                     CR.NRLANBOLREC  = BO.NRLANBOLREC
                     AND (NOT CR.IDSTATREC IN ('B', 'C'))
                     AND (NVL(BO.CDCARTCOBBOL, '1') = '1')
                  UNION
                  SELECT SUM(MJ.VRFXAJBOLREC) VRATUAREC
                  FROM TIPOAJRECEBER TA, MOVFXAJBOLR MJ, BOLETRECEBER BO
                  WHERE
                     MJ.CDEMPRESA   = C_EMP.CDEMPRESA      AND
                     MJ.CDCLASSFINA = C_CLASS.CDCLASSFINA  AND
                     MJ.DTMOVFLUXO  = C_DATA.DTDATA        AND
                     MJ.CDAJUCTREC  = TA.CDAJUCTREC        AND
                     TA.IDAJUCTREC  = 'A'                  AND
                     MJ.CDFILIBOLREC = BO.CDFILIAL         AND
                     MJ.NRLANBOLREC  = BO.NRLANBOLREC
                     AND (NOT BO.IDSTATBREC IN ('B', 'C'))
                     AND (NVL(BO.CDCARTCOBBOL, '1') = '1')
                  UNION
                  SELECT SUM(MJ.VRFXAJBOLREC * -1) VRATUAREC
                  FROM TIPOAJRECEBER TA, MOVFXAJBOLR MJ, BOLETRECEBER BO
                  WHERE
                     MJ.CDEMPRESA   = C_EMP.CDEMPRESA      AND
                     MJ.CDCLASSFINA = C_CLASS.CDCLASSFINA  AND
                     MJ.DTMOVFLUXO  = C_DATA.DTDATA        AND
                     MJ.CDAJUCTREC  = TA.CDAJUCTREC        AND
                     TA.IDAJUCTREC  = 'D'                  AND
                     MJ.CDFILIBOLREC = BO.CDFILIAL         AND
                     MJ.NRLANBOLREC  = BO.NRLANBOLREC
                     AND (NOT BO.IDSTATBREC IN ('B', 'C'))
                     AND (NVL(BO.CDCARTCOBBOL, '1') = '1')) LOOP

                  IF C_CNTREC.VRATUAREC IS NULL THEN
                     V_TOTALDIA := V_TOTALDIA + 0;
                  ELSE
                     V_TOTALDIA := V_TOTALDIA + C_CNTREC.VRATUAREC;
                  END IF;
               END LOOP;

               IF (V_NRCOLUNA > 1) OR (V_IDATRASO = 'S') THEN
                  ALTERA_TRAB_PREV(P_CDFILIAL, P_NRPREVISAO,  LPAD(TO_CHAR(V_NRREGIENCA), 10, '0'),
                                   V_NRCOLUNA, C_DATA.DTDATA, V_TOTALDIA);
               ELSE
                  INSERT INTO TRAB_PREV(
                     CDFILIPREV,   NRPREVISAO, NRREGIPREV,
                     NRPAGIPREV,   CDGRUPPREV, CDEMPRPREV,
                     CDITEMPREV,   DSITEMPREV,
                     DTDIA01PREV,  VRDIA01PREV,
                     DTINIPERPREV, DTFINPERPREV)
                  VALUES(
                     P_CDFILIAL,          P_NRPREVISAO, LPAD(TO_CHAR(V_NRREGIENCA), 10, '0'),
                     V_NRPAGINA,          '04',         C_EMP.CDEMPRESA,
                     C_CLASS.CDCLASSFINA, C_CLASS.DSCLASSFINA,
                     C_DATA.DTDATA,       V_TOTALDIA,
                     P_DTPERIINIC,        P_DTPERIFINA);
               END IF;

               /* CONTROLA A COLUNA E A PGINA DO RELATRIO */
               V_NRCOLUNA   := V_NRCOLUNA + 1;
               IF V_NRCOLUNA > 6 THEN
                  V_NRPAGINA   := V_NRPAGINA + 1;
                  V_NRCOLUNA   := 1;
                  V_NRREGIENCA := V_NRREGIENCA + 1;
                  V_IDATRASO   := 'N';
               END IF;
            END LOOP;
            V_NRREGIENCA := V_NRREGIENCA + 1;
         END IF;
      END LOOP;
   END LOOP;


   /* -------------------------------------------------------------*/
   /* -- GRAVA O VALOR DAS CONTAS A RECEBER (BAIXADAS) [GRUPO 05] -*/
   /*                  OUTROS RECEBIMENTOS      [OK]                */
   /* -------------------------------------------------------------*/
   FOR C_EMP IN C_EMPRESA LOOP
      FOR C_CLASS IN C_CLASSFINANC LOOP
         V_NRPAGINA   := 1;
         V_IDATRASO := 'N';

         SELECT COUNT(*) INTO V_CTCONTA
         FROM
            NOTAFISCAL   NF,
            CONTARECEBER CR,
            BOLETRECEBER BO
         WHERE
            CR.CDEMPRESA    = C_EMP.CDEMPRESA      AND
            CR.CDCLASSFINA  = C_CLASS.CDCLASSFINA  AND
            CR.DTMOVFLUXO BETWEEN P_DTPERIINIC AND P_DTPERIFINA AND
            NF.CDFILIAL     = CR.CDFILIAL          AND
            NF.NRLANCTONF   = CR.NRLANCTONF        AND
            NF.IDSTATUS  IN ('A', 'E')             AND
            CR.CDFILIBOLREC = BO.CDFILIAL          AND
            CR.NRLANBOLREC  = BO.NRLANBOLREC
            AND (CR.IDSTATREC IN ('B'))
            AND (BO.CDCARTCOBBOL IS NULL);

         IF (V_IDATRASO = 'S') OR (V_CTCONTA > 0) THEN
            /* GRAVA OS VALORES DAS CONTAS A RECEBER */
            V_NRCOLUNA := 1;
            FOR C_DATA IN C_PERIODO LOOP

               V_TOTALDIA := 0;
               FOR C_CNTREC IN (
                  SELECT SUM(CR.VRATUAREC) VRATUAREC
                  FROM
                     NOTAFISCAL   NF,
                     CONTARECEBER CR,
                     BOLETRECEBER BO
                  WHERE
                     CR.CDEMPRESA    = C_EMP.CDEMPRESA      AND
                     CR.CDCLASSFINA  = C_CLASS.CDCLASSFINA  AND
                     CR.DTMOVFLUXO = C_DATA.DTDATA        AND
                     NF.CDFILIAL     = CR.CDFILIAL          AND
                     NF.NRLANCTONF   = CR.NRLANCTONF        AND
                     NF.IDSTATUS  IN ('A', 'E')             AND
                     CR.CDFILIBOLREC = BO.CDFILIAL          AND
                     CR.NRLANBOLREC  = BO.NRLANBOLREC
                     AND (CR.IDSTATREC IN ('B'))
                     AND (BO.CDCARTCOBBOL IS NULL)
                  UNION
                  SELECT SUM(MJ.VRFXAJBOLREC) VRATUAREC
                  FROM TIPOAJRECEBER TA, MOVFXAJBOLR MJ, BOLETRECEBER BO
                  WHERE
                     MJ.CDEMPRESA   = C_EMP.CDEMPRESA      AND
                     MJ.CDCLASSFINA = C_CLASS.CDCLASSFINA  AND
                     MJ.DTMOVFLUXO  = C_DATA.DTDATA        AND
                     MJ.CDAJUCTREC  = TA.CDAJUCTREC        AND
                     TA.IDAJUCTREC  = 'A'                  AND
                     MJ.CDFILIBOLREC = BO.CDFILIAL         AND
                     MJ.NRLANBOLREC  = BO.NRLANBOLREC
                     AND (BO.IDSTATBREC IN ('B'))
                     AND (BO.CDCARTCOBBOL IS NULL)
                  UNION
                  SELECT SUM(MJ.VRFXAJBOLREC * -1) VRATUAREC
                  FROM TIPOAJRECEBER TA, MOVFXAJBOLR MJ, BOLETRECEBER BO
                  WHERE
                     MJ.CDEMPRESA   = C_EMP.CDEMPRESA      AND
                     MJ.CDCLASSFINA = C_CLASS.CDCLASSFINA  AND
                     MJ.DTMOVFLUXO  = C_DATA.DTDATA        AND
                     MJ.CDAJUCTREC  = TA.CDAJUCTREC        AND
                     TA.IDAJUCTREC  = 'D'                  AND
                     MJ.CDFILIBOLREC = BO.CDFILIAL         AND
                     MJ.NRLANBOLREC  = BO.NRLANBOLREC
                     AND (BO.IDSTATBREC IN ('B'))
                     AND (BO.CDCARTCOBBOL IS NULL)) LOOP

                  IF C_CNTREC.VRATUAREC IS NULL THEN
                     V_TOTALDIA := V_TOTALDIA + 0;
                  ELSE
                     V_TOTALDIA := V_TOTALDIA + C_CNTREC.VRATUAREC;
                  END IF;
               END LOOP;

               IF (V_NRCOLUNA > 1) OR (V_IDATRASO = 'S') THEN
                  ALTERA_TRAB_PREV(P_CDFILIAL, P_NRPREVISAO,  LPAD(TO_CHAR(V_NRREGIENCA), 10, '0'),
                                   V_NRCOLUNA, C_DATA.DTDATA, V_TOTALDIA);
               ELSE
                  INSERT INTO TRAB_PREV(
                     CDFILIPREV,   NRPREVISAO, NRREGIPREV,
                     NRPAGIPREV,   CDGRUPPREV, CDEMPRPREV,
                     CDITEMPREV,   DSITEMPREV,
                     DTDIA01PREV,  VRDIA01PREV,
                     DTINIPERPREV, DTFINPERPREV)
                  VALUES(
                     P_CDFILIAL,          P_NRPREVISAO, LPAD(TO_CHAR(V_NRREGIENCA), 10, '0'),
                     V_NRPAGINA,          '05',         C_EMP.CDEMPRESA,
                     C_CLASS.CDCLASSFINA, C_CLASS.DSCLASSFINA,
                     C_DATA.DTDATA,       V_TOTALDIA,
                     P_DTPERIINIC,        P_DTPERIFINA);
               END IF;

               /* CONTROLA A COLUNA E A PGINA DO RELATRIO */
               V_NRCOLUNA   := V_NRCOLUNA + 1;
               IF V_NRCOLUNA > 6 THEN
                  V_NRPAGINA   := V_NRPAGINA + 1;
                  V_NRCOLUNA   := 1;
                  V_NRREGIENCA := V_NRREGIENCA + 1;
                  V_IDATRASO   := 'N';
               END IF;
            END LOOP;
            V_NRREGIENCA := V_NRREGIENCA + 1;
         END IF;
      END LOOP;
   END LOOP;


   /* -------------------------------------------------------------*/
   /* --- GRAVA O VALOR DOS MOVIMENTOS DE CREDITOS  [GRUPO 06] --- */
   /*                  RECEITAS FINANCEIRAS   [OK]                     */
   /* -------------------------------------------------------------*/
   V_NRREGIENCA := V_NRREGIENCA + 1;
   FOR C_EMP IN C_EMPRESA LOOP
      FOR C_CLASS IN C_CLASSFINANC LOOP
         V_NRCOLUNA   := 1;
         V_NRPAGINA   := 1;

         SELECT COUNT(*) INTO V_CTCONTA
         FROM MOVCREDBANC
         WHERE
            CDTPCREDBANC <> '04' AND
            DTMOVICRED BETWEEN P_DTPERIINIC AND P_DTPERIFINA AND
            CDCLASSFINA = C_CLASS.CDCLASSFINA AND
            CDEMPRESA   = C_EMP.CDEMPRESA;

         IF V_CTCONTA > 0 THEN
            FOR C_DATA IN C_PERIODO LOOP
               V_TOTALDIA := 0;
               SELECT SUM(VRMOVICRED) INTO V_TOTALDIA
               FROM MOVCREDBANC
               WHERE
                  CDTPCREDBANC <> '04' AND
                  DTMOVICRED  = C_DATA.DTDATA       AND
                  CDCLASSFINA = C_CLASS.CDCLASSFINA AND
                  CDEMPRESA   = C_EMP.CDEMPRESA;

               IF V_TOTALDIA IS NULL THEN
                  V_TOTALDIA := 0;
               END IF;
               IF (V_NRCOLUNA > 1) THEN
                  ALTERA_TRAB_PREV(P_CDFILIAL, P_NRPREVISAO,  LPAD(TO_CHAR(V_NRREGIENCA), 10, '0'),
                                   V_NRCOLUNA, C_DATA.DTDATA, V_TOTALDIA);
               ELSE
                  INSERT INTO TRAB_PREV(
                     CDFILIPREV,   NRPREVISAO, NRREGIPREV,
                     NRPAGIPREV,   CDGRUPPREV, CDEMPRPREV,
                     CDITEMPREV,   DSITEMPREV,
                     DTDIA01PREV,  VRDIA01PREV,
                     DTINIPERPREV, DTFINPERPREV)
                  VALUES(
                     P_CDFILIAL,          P_NRPREVISAO, LPAD(TO_CHAR(V_NRREGIENCA), 10, '0'),
                     V_NRPAGINA,          '06',         C_EMP.CDEMPRESA,
                     C_CLASS.CDCLASSFINA, C_CLASS.DSCLASSFINA,
                     C_DATA.DTDATA,       V_TOTALDIA,
                     P_DTPERIINIC,        P_DTPERIFINA);
               END IF;

               /* CONTROLA A COLUNA E A PGINA DO RELATRIO */
               V_NRCOLUNA   := V_NRCOLUNA + 1;
               IF V_NRCOLUNA > 6 THEN
                  V_NRPAGINA   := V_NRPAGINA + 1;
                  V_NRCOLUNA   := 1;
                  V_NRREGIENCA := V_NRREGIENCA + 1;
               END IF;
            END LOOP;
            V_NRREGIENCA := V_NRREGIENCA + 1;
         END IF;
      END LOOP;
   END LOOP;

   /* -------------------------------------------------------------*/
   /* ----- GRAVA O VALOR DAS PREVISOES DE ENTRADA [GRUPO 07] ---- */
   /* -------------------------------------------------------------*/
   FOR C_EMP IN C_EMPRESA LOOP
      V_NRPAGINA   := 1;
      V_NRCOLUNA   := 1;
      FOR C_DATA IN C_PERIODO LOOP

         V_TOTALDIA := 0;
         FOR C_PREVENT IN
           (SELECT CDCLIENTE, SUM(VRPREVENTR) VRPREVENTR
            FROM PREVENTRADA
            WHERE
               DTPREVENTR = C_DATA.DTDATA AND
               CDEMPRESA  = C_EMP.CDEMPRESA
            GROUP BY CDCLIENTE) LOOP

            SELECT COUNT(CR.CDFILIAL)
            INTO V_CTCONTA
            FROM
               NOTAFISCAL   NF,
               CONTARECEBER CR, BOLETRECEBER BO
            WHERE
               CR.CDEMPRESA     = C_EMP.CDEMPRESA     AND
               CR.DTORIGVENREC  = C_DATA.DTDATA       AND
               NF.CDFILIAL      = CR.CDFILIAL         AND
               NF.NRLANCTONF    = CR.NRLANCTONF       AND
               NF.CDCLIENTE     = C_PREVENT.CDCLIENTE AND
               CR.CDFILIBOLREC  = BO.CDFILIAL          AND
               CR.NRLANBOLREC   = BO.NRLANBOLREC
               AND (CR.IDSTATREC <> 'C')
               AND (NOT (NVL(BO.CDCARTCOBBOL, '00') IN ('51', '33', '31', '05')))
               AND NF.IDSTATUS  IN ('A', 'E');

            IF (V_CTCONTA IS NULL) OR
               (V_CTCONTA = 0)     THEN
               V_TOTALDIA := V_TOTALDIA + C_PREVENT.VRPREVENTR;
            END IF;
         END LOOP;

         IF V_TOTALDIA > 0 THEN
            IF (V_NRCOLUNA > 1) THEN
               ALTERA_TRAB_PREV(P_CDFILIAL, P_NRPREVISAO,  LPAD(TO_CHAR(V_NRREGIENCA), 10, '0'),
                                V_NRCOLUNA, C_DATA.DTDATA, V_TOTALDIA);
            ELSE
               INSERT INTO TRAB_PREV(
                  CDFILIPREV,   NRPREVISAO, NRREGIPREV,
                  NRPAGIPREV,   CDGRUPPREV, CDEMPRPREV,
                  CDITEMPREV,   DSITEMPREV,
                  DTDIA01PREV,  VRDIA01PREV,
                  DTINIPERPREV, DTFINPERPREV)
               VALUES(
                  P_CDFILIAL,    P_NRPREVISAO, LPAD(TO_CHAR(V_NRREGIENCA), 10, '0'),
                  V_NRPAGINA,    '07',         C_EMP.CDEMPRESA,
                  '0000000000',  'E',          /* NAO IRA BUSCAR POIS NAO POSSUI CTB */
                  C_DATA.DTDATA, V_TOTALDIA,
                  P_DTPERIINIC,  P_DTPERIFINA);
            END IF;
         END IF;

         /* CONTROLA A COLUNA E A PGINA DO RELATRIO */
         V_NRCOLUNA   := V_NRCOLUNA + 1;
         IF V_NRCOLUNA > 6 THEN
            V_NRPAGINA   := V_NRPAGINA + 1;
            V_NRCOLUNA   := 1;
            V_NRREGIENCA := V_NRREGIENCA + 1;
         END IF;
      END LOOP;
      V_NRREGIENCA := V_NRREGIENCA + 1;
   END LOOP;

   /* -------------------------------------------------------------*/
   /* -- GRAVA O VALOR DAS CONTAS A RECEBER PREVISTAS [GRUPO 08] - */
   /* -------------------------------------------------------------*/
   FOR C_EMP IN C_EMPRESA LOOP
      FOR C_CLASS IN C_CLASSFINANC LOOP
         V_NRPAGINA   := 1;
         V_NRCOLUNA   := 1;

         SELECT COUNT(*) INTO V_CTCONTA
         FROM
            NOTAFISCAL NF,
            CONTARECEBER CR
         WHERE
            CR.CDEMPRESA    = C_EMP.CDEMPRESA          AND
            CR.CDCLASSFINA  = C_CLASS.CDCLASSFINA      AND
            CR.DTMOVFLUXO BETWEEN P_DTPERIINIC AND P_DTPERIFINA AND
            NF.CDFILIAL     = CR.CDFILIAL              AND
            NF.NRLANCTONF   = CR.NRLANCTONF            AND
            CR.IDSTATREC <> 'C'                        AND
            NF.IDSTATUS     = 'V';

         IF V_CTCONTA > 0 THEN
            FOR C_DATA IN C_PERIODO LOOP

               SELECT SUM(VRATUAREC)
               INTO V_TOTALDIA
               FROM
                  NOTAFISCAL NF,
                  CONTARECEBER CR
               WHERE
                  CR.CDEMPRESA    = C_EMP.CDEMPRESA     AND
                  CR.CDCLASSFINA  = C_CLASS.CDCLASSFINA AND
                  CR.DTMOVFLUXO = C_DATA.DTDATA       AND
                  NF.CDFILIAL     = CR.CDFILIAL         AND
                  NF.NRLANCTONF   = CR.NRLANCTONF       AND
                  CR.IDSTATREC <> 'C'                   AND
                  NF.IDSTATUS     = 'V';

               IF V_TOTALDIA > 0 THEN
                  V_TOTALDIA := V_TOTALDIA;
               END IF;

               IF (V_NRCOLUNA > 1) THEN
                  ALTERA_TRAB_PREV(P_CDFILIAL, P_NRPREVISAO,  LPAD(TO_CHAR(V_NRREGIENCA), 10, '0'),
                                   V_NRCOLUNA, C_DATA.DTDATA, V_TOTALDIA);
               ELSE
                  INSERT INTO TRAB_PREV(
                     CDFILIPREV,   NRPREVISAO, NRREGIPREV,
                     NRPAGIPREV,   CDGRUPPREV, CDEMPRPREV,
                     CDITEMPREV,   DSITEMPREV,
                     DTDIA01PREV,  VRDIA01PREV,
                     DTINIPERPREV, DTFINPERPREV)
                  VALUES(
                     P_CDFILIAL,    P_NRPREVISAO, LPAD(TO_CHAR(V_NRREGIENCA), 10, '0'),
                     V_NRPAGINA,    '08',         C_EMP.CDEMPRESA,
                     C_CLASS.CDCLASSFINA,         C_CLASS.DSCLASSFINA,
                     C_DATA.DTDATA, V_TOTALDIA,    /* NAO IRA BUSCAR POIS NAO POSSUI CTB */
                     P_DTPERIINIC,  P_DTPERIFINA);
               END IF;

               /* CONTROLA A COLUNA E A PGINA DO RELATRIO */
               V_NRCOLUNA   := V_NRCOLUNA + 1;
               IF V_NRCOLUNA > 6 THEN
                  V_NRPAGINA   := V_NRPAGINA + 1;
                  V_NRCOLUNA   := 1;
                  V_NRREGIENCA := V_NRREGIENCA + 1;
               END IF;
            END LOOP;
            V_NRREGIENCA := V_NRREGIENCA + 1;
         END IF;
      END LOOP;
   END LOOP;

   /* -------------------------------------------------------------*/
   /* --- GRAVA O VALOR DAS CONTAS A PAGAR (ABERTAS) [GRUPO 20] -- */
   /* -------------------------------------------------------------*/
   FOR C_EMP IN C_EMPRESA LOOP
      FOR C_CLASS IN C_CLASSFINANC LOOP
         V_NRPAGINA   := 1;

         /* GRAVA OS VALORES DAS CONTAS A PAGAR EM ATRASO */
         SELECT SUM(CP.VRATUAPAG) INTO V_TOTALDIA
         FROM
            (SELECT SUM(CP.VRATUAPAG) VRATUAPAG
             FROM
                NOTAFISCAL NF,
                CONTAPAGAR CP
             WHERE
                CP.CDEMPRESA    = C_EMP.CDEMPRESA      AND
                CP.DTMOVFLUXO <= P_DTPERIINIC - 1      AND
                CP.CDCLASSFINA  = C_CLASS.CDCLASSFINA  AND
                NOT CP.IDSTATPAG IN ('B', 'C')         AND
                NF.CDFILIAL     = CP.CDFILIAL          AND
                NF.NRLANCTONF   = CP.NRLANCTONF        AND
                NF.IDSTATUS     = 'A'
             UNION
             SELECT SUM(MJ.VRFXAJBOLPAG) VRATUAPAG
             FROM TIPOAJPAGAR TA, MOVFXAJBOLP MJ, BOLETPAGAR BO
             WHERE
                MJ.CDEMPRESA   = C_EMP.CDEMPRESA      AND
                MJ.CDCLASSFINA = C_CLASS.CDCLASSFINA  AND
                MJ.DTMOVFLUXO  <= P_DTPERIINIC - 1    AND
                MJ.CDAJUCTPAG  = TA.CDAJUCTPAG        AND
                NOT BO.IDSTATBPAG IN ('B', 'C')       AND
                MJ.CDFILIBOLPAG = BO.CDFILIAL         AND
                MJ.NRLANBOLPAG  = BO.NRLANBOLPAG      AND
                TA.IDAJUCTPAG  = 'A'
             UNION
             SELECT SUM(MJ.VRFXAJBOLPAG * -1) VRATUAPAG
             FROM TIPOAJPAGAR TA, MOVFXAJBOLP MJ, BOLETPAGAR BO
             WHERE
                MJ.CDEMPRESA   = C_EMP.CDEMPRESA      AND
                MJ.CDCLASSFINA = C_CLASS.CDCLASSFINA  AND
                MJ.DTMOVFLUXO  <= P_DTPERIINIC - 1    AND
                MJ.CDAJUCTPAG  = TA.CDAJUCTPAG        AND
                NOT BO.IDSTATBPAG IN ('B', 'C')       AND
                MJ.CDFILIBOLPAG = BO.CDFILIAL         AND
                MJ.NRLANBOLPAG  = BO.NRLANBOLPAG      AND
                TA.IDAJUCTPAG  = 'D') CP;

         V_IDATRASO := 'N';
         IF V_TOTALDIA > 0 THEN
            INSERT INTO TRAB_PREV(
               CDFILIPREV,   NRPREVISAO, NRREGIPREV,
               NRPAGIPREV,   CDGRUPPREV, CDEMPRPREV,
               CDITEMPREV,   DSITEMPREV, VRATRASOPREV,
               DTINIPERPREV, DTFINPERPREV)
            VALUES(
               P_CDFILIAL,          P_NRPREVISAO,        LPAD(TO_CHAR(V_NRREGIENCA), 10, '0'),
               V_NRPAGINA,          '20',                C_EMP.CDEMPRESA,
               C_CLASS.CDCLASSFINA, C_CLASS.DSCLASSFINA, (ABS(V_TOTALDIA) * -1),
               P_DTPERIINIC,        P_DTPERIFINA);

               V_IDATRASO := 'S';
         END IF;

         SELECT COUNT(*) INTO V_CTCONTA
         FROM
            NOTAFISCAL NF,
            CONTAPAGAR CP
         WHERE
            CP.CDEMPRESA    = C_EMP.CDEMPRESA      AND
            CP.CDCLASSFINA  = C_CLASS.CDCLASSFINA  AND
            CP.DTMOVFLUXO BETWEEN P_DTPERIINIC AND P_DTPERIFINA AND
            CP.IDSTATPAG <> 'C'                    AND
            NF.CDFILIAL     = CP.CDFILIAL          AND
            NF.NRLANCTONF   = CP.NRLANCTONF        AND
            NF.IDSTATUS     = 'A';

         IF (V_IDATRASO = 'S') OR (V_CTCONTA > 0) THEN
            /* GRAVA OS VALORES DAS CONTAS A PAGAR */
            V_NRCOLUNA := 1;
            FOR C_DATA IN C_PERIODO LOOP

               V_TOTALDIA := 0;
               FOR C_CNTREC IN (
                  SELECT SUM(CP.VRATUAPAG) VRATUAPAG
                  FROM
                     NOTAFISCAL NF,
                     CONTAPAGAR CP
                  WHERE
                     CP.CDEMPRESA    = C_EMP.CDEMPRESA      AND
                     CP.DTMOVFLUXO = C_DATA.DTDATA        AND
                     CP.CDCLASSFINA  = C_CLASS.CDCLASSFINA  AND
                     CP.IDSTATPAG <> 'C'                    AND
                     NF.CDFILIAL     = CP.CDFILIAL          AND
                     NF.NRLANCTONF   = CP.NRLANCTONF        AND
                     NF.IDSTATUS     = 'A'
                  UNION
                  SELECT SUM(MJ.VRFXAJBOLPAG) VRATUAPAG
                  FROM TIPOAJPAGAR TA, MOVFXAJBOLP MJ, BOLETPAGAR BO
                  WHERE
                     MJ.CDEMPRESA   = C_EMP.CDEMPRESA      AND
                     MJ.CDCLASSFINA = C_CLASS.CDCLASSFINA  AND
                     MJ.DTMOVFLUXO  = C_DATA.DTDATA        AND
                     MJ.CDAJUCTPAG  = TA.CDAJUCTPAG        AND
                     MJ.CDFILIBOLPAG = BO.CDFILIAL         AND
                     MJ.NRLANBOLPAG  = BO.NRLANBOLPAG      AND
                     BO.IDSTATBPAG <> 'C'                  AND
                     TA.IDAJUCTPAG  = 'A'
                  UNION
                  SELECT SUM(MJ.VRFXAJBOLPAG * -1) VRATUAPAG
                  FROM TIPOAJPAGAR TA, MOVFXAJBOLP MJ, BOLETPAGAR BO
                  WHERE
                     MJ.CDEMPRESA   = C_EMP.CDEMPRESA      AND
                     MJ.CDCLASSFINA = C_CLASS.CDCLASSFINA  AND
                     MJ.DTMOVFLUXO  = C_DATA.DTDATA        AND
                     MJ.CDAJUCTPAG  = TA.CDAJUCTPAG        AND
                     MJ.CDFILIBOLPAG = BO.CDFILIAL         AND
                     MJ.NRLANBOLPAG  = BO.NRLANBOLPAG      AND
                     BO.IDSTATBPAG <> 'C'                  AND
                     TA.IDAJUCTPAG  = 'D') LOOP
                  IF C_CNTREC.VRATUAPAG IS NULL THEN
                     V_TOTALDIA := V_TOTALDIA + 0;
                  ELSE
                     V_TOTALDIA := V_TOTALDIA - C_CNTREC.VRATUAPAG;
                  END IF;
               END LOOP;

               IF (V_NRCOLUNA > 1) OR (V_IDATRASO = 'S') THEN
                  ALTERA_TRAB_PREV(P_CDFILIAL, P_NRPREVISAO,  LPAD(TO_CHAR(V_NRREGIENCA), 10, '0'),
                                   V_NRCOLUNA, C_DATA.DTDATA, (ABS(V_TOTALDIA) * -1));
               ELSE
                  INSERT INTO TRAB_PREV(
                     CDFILIPREV,   NRPREVISAO, NRREGIPREV,
                     NRPAGIPREV,   CDGRUPPREV, CDEMPRPREV,
                     CDITEMPREV,   DSITEMPREV,
                     DTDIA01PREV,  VRDIA01PREV,
                     DTINIPERPREV, DTFINPERPREV)
                  VALUES(
                     P_CDFILIAL,          P_NRPREVISAO, LPAD(TO_CHAR(V_NRREGIENCA), 10, '0'),
                     V_NRPAGINA,          '20',         C_EMP.CDEMPRESA,
                     C_CLASS.CDCLASSFINA, C_CLASS.DSCLASSFINA,
                     C_DATA.DTDATA,       (ABS(V_TOTALDIA) * -1),
                     P_DTPERIINIC,        P_DTPERIFINA);
               END IF;

               /* CONTROLA A COLUNA E A PGINA DO RELATRIO */
               V_NRCOLUNA   := V_NRCOLUNA + 1;
               IF V_NRCOLUNA > 6 THEN
                  V_NRPAGINA   := V_NRPAGINA + 1;
                  V_NRCOLUNA   := 1;
                  V_NRREGIENCA := V_NRREGIENCA + 1;
                  V_IDATRASO   := 'N';
               END IF;
            END LOOP;
            V_NRREGIENCA := V_NRREGIENCA + 1;
         END IF;
      END LOOP;
   END LOOP;

   /* -------------------------------------------------------------*/
   /* ------ GRAVA O VALOR DAS PREVISES DE SAIDA [GRUPO 21] ----- */
   /* -------------------------------------------------------------*/
   FOR C_EMP IN C_EMPRESA LOOP
      V_NRPAGINA   := 1;
      V_NRCOLUNA   := 1;
      FOR C_DATA IN C_PERIODO LOOP

         V_TOTALDIA := 0;
         FOR C_PREVSAID IN (
            SELECT CDFORNECED, SUM(VRPREVSAIDA) VRPREVSAIDA
            FROM PREVSAIDA
            WHERE
               DTPREVSAIDA = C_DATA.DTDATA AND
               CDEMPRESA   = C_EMP.CDEMPRESA
            GROUP BY
               CDFORNECED) LOOP

            SELECT COUNT(CP.CDFILIAL)
            INTO V_CTCONTA
            FROM
               NOTAFISCAL   NF,
               CONTAPAGAR CP
            WHERE
               CP.CDEMPRESA     = C_EMP.CDEMPRESA     AND
               CP.DTORIGVENPAG  = C_DATA.DTDATA       AND
               NF.CDFILIAL      = CP.CDFILIAL         AND
               NF.NRLANCTONF    = CP.NRLANCTONF       AND
               NF.CDFORNECED   = C_PREVSAID.CDFORNECED AND
               NF.IDSTATUS  IN ('A', 'E');

            IF (V_CTCONTA IS NULL) OR
               (V_CTCONTA = 0)     THEN
               V_TOTALDIA := V_TOTALDIA - C_PREVSAID.VRPREVSAIDA;
            END IF;
         END LOOP;


         IF V_TOTALDIA <> 0 THEN
            IF (V_NRCOLUNA > 1) THEN
               ALTERA_TRAB_PREV(P_CDFILIAL, P_NRPREVISAO,  LPAD(TO_CHAR(V_NRREGIENCA), 10, '0'),
                                V_NRCOLUNA, C_DATA.DTDATA, (ABS(V_TOTALDIA) * -1));
            ELSE
               INSERT INTO TRAB_PREV(
                  CDFILIPREV,   NRPREVISAO, NRREGIPREV,
                  NRPAGIPREV,   CDGRUPPREV, CDEMPRPREV,
                  CDITEMPREV,   DSITEMPREV,
                  DTDIA01PREV,  VRDIA01PREV,
                  DTINIPERPREV, DTFINPERPREV)
               VALUES(
                  P_CDFILIAL,    P_NRPREVISAO, LPAD(TO_CHAR(V_NRREGIENCA), 10, '0'),
                  V_NRPAGINA,    '20',         C_EMP.CDEMPRESA,
                  '0000000000',  'S',               /* NAO IRA BUSCAR POIS NAO POSSUI CTB */
                  C_DATA.DTDATA, (ABS(V_TOTALDIA) * -1),
                  P_DTPERIINIC,  P_DTPERIFINA);
            END IF;
         END IF;

         /* CONTROLA A COLUNA E A PGINA DO RELATRIO */
         V_NRCOLUNA   := V_NRCOLUNA + 1;
         IF V_NRCOLUNA > 6 THEN
            V_NRPAGINA   := V_NRPAGINA + 1;
            V_NRCOLUNA   := 1;
            V_NRREGIENCA := V_NRREGIENCA + 1;
         END IF;
      END LOOP;
      V_NRREGIENCA := V_NRREGIENCA + 1;
   END LOOP;

   /* -------------------------------------------------------------*/
   /* --- GRAVA O VALOR DAS CONTAS A PAGAR PREVISTAS [GRUPO 22] -- */
   /* -------------------------------------------------------------*/
   FOR C_EMP IN C_EMPRESA LOOP
      FOR C_CLASS IN C_CLASSFINANC LOOP
         V_NRPAGINA   := 1;
         V_NRCOLUNA   := 1;

         SELECT COUNT(*) INTO V_CTCONTA
         FROM
            NOTAFISCAL NF,
            CONTAPAGAR CP
         WHERE
            CP.CDEMPRESA    = C_EMP.CDEMPRESA          AND
            CP.CDCLASSFINA  = C_CLASS.CDCLASSFINA      AND
            CP.DTMOVFLUXO BETWEEN P_DTPERIINIC AND P_DTPERIFINA AND
            NF.CDFILIAL     = CP.CDFILIAL              AND
            NF.NRLANCTONF   = CP.NRLANCTONF            AND
            CP.IDSTATPAG <> 'C'                        AND
            NF.IDSTATUS     = 'V';

         IF V_CTCONTA > 0 THEN
            FOR C_DATA IN C_PERIODO LOOP

               SELECT SUM(VRATUAPAG)
               INTO V_TOTALDIA
               FROM
                  NOTAFISCAL NF,
                  CONTAPAGAR CP
               WHERE
                  CP.CDEMPRESA    = C_EMP.CDEMPRESA     AND
                  CP.CDCLASSFINA  = C_CLASS.CDCLASSFINA AND
                  CP.DTMOVFLUXO = C_DATA.DTDATA       AND
                  NF.CDFILIAL     = CP.CDFILIAL         AND
                  NF.NRLANCTONF   = CP.NRLANCTONF       AND
                  CP.IDSTATPAG <> 'C'                   AND
                  NF.IDSTATUS     = 'V';

               IF V_TOTALDIA > 0 THEN
                  V_TOTALDIA := V_TOTALDIA * -1;
               END IF;

               IF (V_NRCOLUNA > 1) THEN
                  ALTERA_TRAB_PREV(P_CDFILIAL, P_NRPREVISAO,  LPAD(TO_CHAR(V_NRREGIENCA), 10, '0'),
                                   V_NRCOLUNA, C_DATA.DTDATA, (ABS(V_TOTALDIA) * -1));
               ELSE
                  INSERT INTO TRAB_PREV(
                     CDFILIPREV,   NRPREVISAO, NRREGIPREV,
                     NRPAGIPREV,   CDGRUPPREV, CDEMPRPREV,
                     CDITEMPREV,   DSITEMPREV,
                     DTDIA01PREV,  VRDIA01PREV,
                     DTINIPERPREV, DTFINPERPREV)
                  VALUES(
                     P_CDFILIAL,    P_NRPREVISAO, LPAD(TO_CHAR(V_NRREGIENCA), 10, '0'),
                     V_NRPAGINA,    '20',         C_EMP.CDEMPRESA,
                     C_CLASS.CDCLASSFINA,         C_CLASS.DSCLASSFINA,
                     C_DATA.DTDATA, (ABS(V_TOTALDIA) * -1),   /* NAO IRA BUSCAR POIS NAO POSSUI CTB */
                     P_DTPERIINIC,  P_DTPERIFINA);
               END IF;

               /* CONTROLA A COLUNA E A PGINA DO RELATRIO */
               V_NRCOLUNA   := V_NRCOLUNA + 1;
               IF V_NRCOLUNA > 6 THEN
                  V_NRPAGINA   := V_NRPAGINA + 1;
                  V_NRCOLUNA   := 1;
                  V_NRREGIENCA := V_NRREGIENCA + 1;
               END IF;
            END LOOP;
            V_NRREGIENCA := V_NRREGIENCA + 1;
         END IF;
      END LOOP;
   END LOOP;

   /* -------------------------------------------------------------*/
   /* --- GRAVA O VALOR DOS MOVIMENTOS DE DEBITOS  [GRUPO 23] ---- */
   /* -------------------------------------------------------------*/
   V_NRREGIENCA := V_NRREGIENCA + 1;
   FOR C_EMP IN C_EMPRESA LOOP
      FOR C_CLASS IN C_CLASSFINANC LOOP
         V_NRCOLUNA   := 1;
         V_NRPAGINA   := 1;

         SELECT COUNT(*) INTO V_CTCONTA
         FROM MOVDEBBANC
         WHERE
            DTMOVIDEBI BETWEEN P_DTPERIINIC AND P_DTPERIFINA AND
            CDCLASSFINA = C_CLASS.CDCLASSFINA AND
            CDEMPRESA   = C_EMP.CDEMPRESA;

         IF V_CTCONTA > 0 THEN
            FOR C_DATA IN C_PERIODO LOOP
               V_TOTALDIA := 0;
               SELECT SUM(VRMOVIDEBI) INTO V_TOTALDIA
               FROM MOVDEBBANC
               WHERE
                  DTMOVIDEBI  = C_DATA.DTDATA       AND
                  CDCLASSFINA = C_CLASS.CDCLASSFINA AND
                  CDEMPRESA   = C_EMP.CDEMPRESA;

               IF V_TOTALDIA IS NULL THEN
                  V_TOTALDIA := 0;
               END IF;
               IF (V_NRCOLUNA > 1) THEN
                  ALTERA_TRAB_PREV(P_CDFILIAL, P_NRPREVISAO,  LPAD(TO_CHAR(V_NRREGIENCA), 10, '0'),
                                   V_NRCOLUNA, C_DATA.DTDATA, (ABS(V_TOTALDIA) * -1));
               ELSE
                  INSERT INTO TRAB_PREV(
                     CDFILIPREV,   NRPREVISAO, NRREGIPREV,
                     NRPAGIPREV,   CDGRUPPREV, CDEMPRPREV,
                     CDITEMPREV,   DSITEMPREV,
                     DTDIA01PREV,  VRDIA01PREV,
                     DTINIPERPREV, DTFINPERPREV)
                  VALUES(
                     P_CDFILIAL,          P_NRPREVISAO, LPAD(TO_CHAR(V_NRREGIENCA), 10, '0'),
                     V_NRPAGINA,          '20',         C_EMP.CDEMPRESA,
                     C_CLASS.CDCLASSFINA, C_CLASS.DSCLASSFINA,
                     C_DATA.DTDATA,       (ABS(V_TOTALDIA) * -1),
                     P_DTPERIINIC,        P_DTPERIFINA);
               END IF;

               /* CONTROLA A COLUNA E A PGINA DO RELATRIO */
               V_NRCOLUNA   := V_NRCOLUNA + 1;
               IF V_NRCOLUNA > 6 THEN
                  V_NRPAGINA   := V_NRPAGINA + 1;
                  V_NRCOLUNA   := 1;
                  V_NRREGIENCA := V_NRREGIENCA + 1;
               END IF;
            END LOOP;
            V_NRREGIENCA := V_NRREGIENCA + 1;
         END IF;
      END LOOP;
   END LOOP;

   V_TOTMOVIANT := 0;
   FOR C_MOVI IN
   (SELECT NRPAGIPREV,
      MAX(DTDIA01PREV) DT01, MAX(DTDIA02PREV) DT02, MAX(DTDIA03PREV) DT03,
      MAX(DTDIA04PREV) DT04, MAX(DTDIA05PREV) DT05, MAX(DTDIA06PREV) DT06,
      SUM(VRDIA01PREV) DIA01, SUM(VRDIA02PREV) DIA02, SUM(VRDIA03PREV) DIA03,
      SUM(VRDIA04PREV) DIA04, SUM(VRDIA05PREV) DIA05, SUM(VRDIA06PREV) DIA06
    FROM TRAB_PREV
    WHERE
      CDFILIPREV = P_CDFILIAL AND
      NRPREVISAO = P_NRPREVISAO AND
      CDGRUPPREV <> '01'
    GROUP BY NRPAGIPREV) LOOP
      V_NRREGIENCA := V_NRREGIENCA + 1;
      INSERT INTO TRAB_PREV(
         CDFILIPREV,   NRPREVISAO, NRREGIPREV,
         NRPAGIPREV,   CDGRUPPREV, CDEMPRPREV,
         CDITEMPREV,   DSITEMPREV,
         DTDIA01PREV,  VRDIA01PREV,
         DTDIA02PREV,  VRDIA02PREV,
         DTDIA03PREV,  VRDIA03PREV,
         DTDIA04PREV,  VRDIA04PREV,
         DTDIA05PREV,  VRDIA05PREV,
         DTDIA06PREV,  VRDIA06PREV,
         DTINIPERPREV, DTFINPERPREV)
      VALUES(
         P_CDFILIAL,    P_NRPREVISAO, LPAD(TO_CHAR(V_NRREGIENCA), 10, '0'),
         C_MOVI.NRPAGIPREV,    '99',         '',
         '',         '',
         C_MOVI.DT01, V_TOTMOVIANT,
         C_MOVI.DT02, V_TOTMOVIANT + C_MOVI.DIA01,
         C_MOVI.DT03, V_TOTMOVIANT + C_MOVI.DIA01 + C_MOVI.DIA02,
         C_MOVI.DT04, V_TOTMOVIANT + C_MOVI.DIA01 + C_MOVI.DIA02 + C_MOVI.DIA03,
         C_MOVI.DT05, V_TOTMOVIANT + C_MOVI.DIA01 + C_MOVI.DIA02 + C_MOVI.DIA03 + C_MOVI.DIA04,
         C_MOVI.DT06, V_TOTMOVIANT + C_MOVI.DIA01 + C_MOVI.DIA02 + C_MOVI.DIA03 + C_MOVI.DIA04 + C_MOVI.DIA05,
         P_DTPERIINIC,  P_DTPERIFINA);

      V_TOTMOVIANT := V_TOTMOVIANT +
                      NVL(C_MOVI.DIA01, 0) + NVL(C_MOVI.DIA02, 0) + NVL(C_MOVI.DIA03, 0) +
                      NVL(C_MOVI.DIA04, 0) + NVL(C_MOVI.DIA05, 0) + NVL(C_MOVI.DIA06, 0);
   END LOOP;

/* ##################################################################################### */
/* #########################    RATEIO POR CENTRO DE CUSTO   ########################### */
/* ##################################################################################### */

   /*  GRUPO  02
   V_NRREGIENCA := V_NRREGIENCA + 1;
   FOR C_EMP IN C_EMPRESA LOOP
      FOR C_CLASS IN C_CLASSFINANC LOOP
         V_NRCOLUNA   := 1;
         V_NRPAGINA   := 1;

         SELECT COUNT(*) INTO V_CTCONTA
         FROM MOVCREDBANC
         WHERE
            CDTPCREDBANC = '04' AND
            DTMOVICRED BETWEEN P_DTPERIINIC AND P_DTPERIFINA AND
            CDCLASSFINA = C_CLASS.CDCLASSFINA AND
            CDEMPRESA   = C_EMP.CDEMPRESA;

         IF  V_CTCONTA > 0 THEN
            FOR C_DATA IN C_PERIODO LOOP
               IF (V_NRCOLUNA = 1)  OR (V_NRCOLUNA > 6) THEN
                  FOR C_CENTCUST IN (SELECT LCC.CDFILIAL,   LCC.CDCENTCUST,
                                            CTC.NMCENTCUST, SUM(LCC.VRLANCCUST) TOTALDIA
                                     FROM
                                        MOVCREDBANC MOV,
                                        LANCCONT    LCT,
                                        LANCCCUSTO  LCC,
                                        CENTCUST    CTC
                                     WHERE
                                        CDTPCREDBANC = '04' AND
                                        CTC.CDCENTCUST   = LCC.CDCENTCUST  AND
                                         MOV.DTMOVICRED BETWEEN P_DTPERIINIC AND P_DTPERIFINA AND
                                        MOV.CDCLASSFINA = C_CLASS.CDCLASSFINA AND
                                        MOV.CDEMPRESA   = C_EMP.CDEMPRESA     AND
                                        MOV.CDECTBMCRED = LCT.CDEMPRESA       AND
                                        MOV.NRLCTBMCRED = LCT.NRLANCCONT      AND
                                        LCC.CDEMPRESA   = LCT.CDEMPRESA       AND
                                        LCC.NRLANCCONT  = LCT.NRLANCCONT      AND
                                        LCC.NRSEQLANC   = LCT.NRSEQLANC
                                     GROUP BY
                                        LCC.CDFILIAL,
                                        LCC.CDCENTCUST,
                                        CTC.NMCENTCUST) LOOP

                     V_CENTCUST := '32'||'02'||C_CENTCUST.CDFILIAL||C_CENTCUST.CDCENTCUST||C_CLASS.CDCLASSFINA;
                     INSERT INTO TRAB_PREV(
                        CDFILIPREV,   NRPREVISAO, NRREGIPREV,
                        NRPAGIPREV,   CDGRUPPREV, CDEMPRPREV,
                        CDITEMPREV,   DSITEMPREV, VRATRASOPREV,
                        DTINIPERPREV, DTFINPERPREV)
                     VALUES(
                        P_CDFILIAL,   P_NRPREVISAO,          LPAD(TO_CHAR(V_NRREGIENCA), 10, '0'),
                        V_NRPAGINA,   '32',                  C_EMP.CDEMPRESA,
                        '001',   V_CENTCUST, 0,
                        P_DTPERIINIC, P_DTPERIFINA);

                     V_NRREGIENCA := V_NRREGIENCA + 1;
                  END LOOP;
                  V_NRPAGINA   := V_NRPAGINA + 1;
                  V_NRCOLUNA   := 0;
               END IF;
               V_NRCOLUNA   := V_NRCOLUNA + 1;
            END LOOP;

            V_NRPAGINA   := 1;
            V_NRCOLUNA   := 1;
            FOR C_DATA IN C_PERIODO LOOP
               FOR C_CENTCUST IN (SELECT LCC.CDFILIAL,   LCC.CDCENTCUST,
                                         CTC.NMCENTCUST, SUM(LCC.VRLANCCUST) TOTALDIA
                                  FROM
                                     MOVCREDBANC MOV,
                                     LANCCONT    LCT,
                                     LANCCCUSTO  LCC,
                                     CENTCUST    CTC
                                  WHERE
                                     CDTPCREDBANC = '04' AND
                                     CTC.CDCENTCUST  = LCC.CDCENTCUST  AND
                                     MOV.DTMOVICRED  = C_DATA.DTDATA   AND
                                     MOV.CDCLASSFINA = C_CLASS.CDCLASSFINA AND
                                     MOV.CDEMPRESA   = C_EMP.CDEMPRESA     AND
                                     MOV.CDECTBMCRED = LCT.CDEMPRESA       AND
                                     MOV.NRLCTBMCRED = LCT.NRLANCCONT      AND
                                     LCC.CDEMPRESA   = LCT.CDEMPRESA       AND
                                     LCC.NRLANCCONT  = LCT.NRLANCCONT      AND
                                     LCC.NRSEQLANC   = LCT.NRSEQLANC
                                  GROUP BY
                                     LCC.CDFILIAL,
                                     LCC.CDCENTCUST,
                                     CTC.NMCENTCUST) LOOP

                  V_CENTCUST := '32'||'02'||C_CENTCUST.CDFILIAL||C_CENTCUST.CDCENTCUST||C_CLASS.CDCLASSFINA;
                  SELECT MAX(NRREGIPREV) INTO V_NRREG_MIN
                  FROM TRAB_PREV
                  WHERE
                     CDFILIPREV = P_CDFILIAL    AND
                     NRPREVISAO = P_NRPREVISAO  AND
                     NRPAGIPREV = V_NRPAGINA    AND
                     DSITEMPREV = V_CENTCUST;

                  ALTERA_TRAB_PREV(P_CDFILIAL, P_NRPREVISAO,  LPAD(TO_CHAR(V_NRREG_MIN), 10, '0'),
                                   V_NRCOLUNA, C_DATA.DTDATA, C_CENTCUST.TOTALDIA);
               END LOOP;

               /* CONTROLA A COLUNA E A PGINA DO RELATRIO
               V_NRCOLUNA   := V_NRCOLUNA + 1;
               IF V_NRCOLUNA > 6 THEN
                  V_NRPAGINA   := V_NRPAGINA + 1;
                  V_NRCOLUNA   := 1;
                  V_NRREGIENCA := V_NRREGIENCA + 1;
               END IF;
            END LOOP;
            V_NRREGIENCA := V_NRREGIENCA + 1;
         END IF;
      END LOOP;
   END LOOP;

   /*  GRUPO 03
   V_NRREGIENCA := V_NRREGIENCA + 1;
   FOR C_EMP IN C_EMPRESA LOOP
      FOR C_CLASS IN C_CLASSFINANC LOOP
         V_NRCOLUNA   := 1;
         V_NRPAGINA   := 1;
         FOR C_DATA IN C_PERIODO LOOP
            IF (V_NRCOLUNA = 1)  OR (V_NRCOLUNA > 6) THEN
               FOR C_CENTCUST IN (SELECT LCC.CDFILIAL,   LCC.CDCENTCUST,
                                         CTC.NMCENTCUST, SUM(((A.VRATUAREC * LCC.VRLANCCUST) / NF.VRNOTAFISC)) TOTALDIA
                                 FROM
                                    (SELECT CDFILIAL, NRLANCTONF, SUM(VRATUAREC) VRATUAREC
                                     FROM
                                        (SELECT NF.CDFILIAL, NF.NRLANCTONF, SUM(CR.VRATUAREC) VRATUAREC
                                         FROM
                                            NOTAFISCAL   NF, CONTARECEBER CR, BOLETRECEBER BO
                                         WHERE
                                            CR.CDEMPRESA    = C_EMP.CDEMPRESA      AND
                                            CR.CDCLASSFINA  = C_CLASS.CDCLASSFINA  AND
                                            CR.DTMOVFLUXO   BETWEEN P_DTPERIINIC AND P_DTPERIFINA AND
                                            NF.CDFILIAL     = CR.CDFILIAL          AND
                                            NF.NRLANCTONF   = CR.NRLANCTONF        AND
                                            NF.IDSTATUS  IN ('A', 'E')             AND
                                            CR.CDFILIBOLREC = BO.CDFILIAL          AND
                                            CR.NRLANBOLREC  = BO.NRLANBOLREC
                                            AND (NOT CR.IDSTATREC IN ('C', 'B'))
                                            AND (BO.CDCARTCOBBOL IN ('01', '11', '09', '15'))
                                         GROUP BY
                                            NF.CDFILIAL, NF.NRLANCTONF
                                         UNION
                                         SELECT NF.CDFILIAL, NF.NRLANCTONF, ((SUM(CR.VRORIGREC)/SUM(BO.VRBOLREC)) * SUM(MJ.VRFXAJBOLREC)) VRATUAREC
                                         FROM TIPOAJRECEBER TA, MOVFXAJBOLR MJ, NOTAFISCAL NF,
                                              CONTARECEBER CR,  BOLETRECEBER BO
                                         WHERE
                                            MJ.CDEMPRESA   = C_EMP.CDEMPRESA      AND
                                            MJ.CDCLASSFINA = C_CLASS.CDCLASSFINA  AND
                                            MJ.DTMOVFLUXO  BETWEEN P_DTPERIINIC AND P_DTPERIFINA AND
                                            MJ.CDAJUCTREC  = TA.CDAJUCTREC        AND
                                            TA.IDAJUCTREC  = 'A'                  AND
                                            NF.CDFILIAL     = CR.CDFILIAL         AND
                                            NF.NRLANCTONF   = CR.NRLANCTONF       AND
                                            CR.CDFILIBOLREC = BO.CDFILIAL         AND
                                            CR.NRLANBOLREC  = BO.NRLANBOLREC      AND
                                            MJ.CDFILIBOLREC = BO.CDFILIAL         AND
                                            MJ.NRLANBOLREC  = BO.NRLANBOLREC
                                            AND (NOT BO.IDSTATBREC IN ('C', 'B'))
                                            AND (BO.CDCARTCOBBOL IN ('01', '11', '09', '15'))
                                         GROUP BY
                                            NF.CDFILIAL, NF.NRLANCTONF
                                         UNION
                                         SELECT NF.CDFILIAL, NF.NRLANCTONF, ((SUM(CR.VRORIGREC)/SUM(BO.VRBOLREC)) * SUM(MJ.VRFXAJBOLREC)) VRATUAREC
                                         FROM TIPOAJRECEBER TA, MOVFXAJBOLR MJ, NOTAFISCAL NF,
                                              CONTARECEBER CR,  BOLETRECEBER BO
                                         WHERE
                                            MJ.CDEMPRESA   = C_EMP.CDEMPRESA      AND
                                            MJ.CDCLASSFINA = C_CLASS.CDCLASSFINA  AND
                                            MJ.DTMOVFLUXO  BETWEEN P_DTPERIINIC AND P_DTPERIFINA AND
                                            MJ.CDAJUCTREC  = TA.CDAJUCTREC        AND
                                            TA.IDAJUCTREC  = 'D'                  AND
                                            NF.CDFILIAL     = CR.CDFILIAL         AND
                                            NF.NRLANCTONF   = CR.NRLANCTONF       AND
                                            CR.CDFILIBOLREC = BO.CDFILIAL         AND
                                            CR.NRLANBOLREC  = BO.NRLANBOLREC      AND
                                            MJ.CDFILIBOLREC = BO.CDFILIAL         AND
                                            MJ.NRLANBOLREC  = BO.NRLANBOLREC
                                            AND (NOT BO.IDSTATBREC IN ('C', 'B'))
                                            AND (BO.CDCARTCOBBOL IN ('01', '11', '09', '15'))
                                         GROUP BY
                                            NF.CDFILIAL, NF.NRLANCTONF)
                                    GROUP BY CDFILIAL, NRLANCTONF) A,
                                    NOTAFISCAL   NF,
                                    LANCCONT     LCT,
                                    LANCCCUSTO   LCC,
                                    CENTCUST     CTC
                                 WHERE
                                        NF.CDFILIAL    = A.CDFILIAL
                                    AND NF.NRLANCTONF  = A.NRLANCTONF
                                    AND CTC.CDCENTCUST = LCC.CDCENTCUST
                                    AND NF.CDEMPRESA   = LCT.CDEMPRESA
                                    AND NF.NRLANCTBDOC = LCT.NRLANCCONT
                                    AND LCC.CDEMPRESA  = LCT.CDEMPRESA
                                    AND LCC.NRLANCCONT = LCT.NRLANCCONT
                                    AND LCC.NRSEQLANC  = LCT.NRSEQLANC
                                 GROUP BY
                                    LCC.CDFILIAL,
                                    LCC.CDCENTCUST,
                                    CTC.NMCENTCUST) LOOP

                  V_CENTCUST := '33'||'03'||C_CENTCUST.CDFILIAL||C_CENTCUST.CDCENTCUST||C_CLASS.CDCLASSFINA;
                  INSERT INTO TRAB_PREV(
                     CDFILIPREV,   NRPREVISAO, NRREGIPREV,
                     NRPAGIPREV,   CDGRUPPREV, CDEMPRPREV,
                     CDITEMPREV,   DSITEMPREV, VRATRASOPREV,
                     DTINIPERPREV, DTFINPERPREV)
                  VALUES(
                     P_CDFILIAL,   P_NRPREVISAO,          LPAD(TO_CHAR(V_NRREGIENCA), 10, '0'),
                     V_NRPAGINA,   '33',                  C_EMP.CDEMPRESA,
                     '001', V_CENTCUST,   0,
                     P_DTPERIINIC, P_DTPERIFINA);

                  V_NRREGIENCA := V_NRREGIENCA + 1;
               END LOOP;
               V_NRPAGINA   := V_NRPAGINA + 1;
               V_NRCOLUNA   := 0;
            END IF;
            V_NRCOLUNA   := V_NRCOLUNA + 1;
         END LOOP;

         V_NRPAGINA   := 1;
         V_NRCOLUNA   := 1;
         FOR C_DATA IN C_PERIODO LOOP
               FOR C_CENTCUST IN (SELECT LCC.CDFILIAL,   LCC.CDCENTCUST,
                                         CTC.NMCENTCUST, SUM(((A.VRATUAREC * LCC.VRLANCCUST) / NF.VRNOTAFISC)) TOTALDIA
                                 FROM
                                    (SELECT CDFILIAL, NRLANCTONF, SUM(VRATUAREC) VRATUAREC
                                     FROM
                                        (SELECT NF.CDFILIAL, NF.NRLANCTONF, SUM(CR.VRATUAREC) VRATUAREC
                                         FROM
                                            NOTAFISCAL   NF, CONTARECEBER CR, BOLETRECEBER BO
                                         WHERE
                                            CR.CDEMPRESA    = C_EMP.CDEMPRESA      AND
                                            CR.CDCLASSFINA  = C_CLASS.CDCLASSFINA  AND
                                            CR.DTMOVFLUXO   = C_DATA.DTDATA   AND
                                            NF.CDFILIAL     = CR.CDFILIAL          AND
                                            NF.NRLANCTONF   = CR.NRLANCTONF        AND
                                            NF.IDSTATUS  IN ('A', 'E')             AND
                                            CR.CDFILIBOLREC = BO.CDFILIAL          AND
                                            CR.NRLANBOLREC  = BO.NRLANBOLREC
                                            AND (NOT CR.IDSTATREC IN ('C', 'B'))
                                            AND (BO.CDCARTCOBBOL IN ('01', '11', '09', '15'))
                                         GROUP BY
                                            NF.CDFILIAL, NF.NRLANCTONF
                                         UNION
                                         SELECT NF.CDFILIAL, NF.NRLANCTONF, ((SUM(CR.VRORIGREC)/SUM(BO.VRBOLREC)) * SUM(MJ.VRFXAJBOLREC)) VRATUAREC
                                         FROM TIPOAJRECEBER TA, MOVFXAJBOLR MJ, NOTAFISCAL NF,
                                              CONTARECEBER CR,  BOLETRECEBER BO
                                         WHERE
                                            MJ.CDEMPRESA   = C_EMP.CDEMPRESA      AND
                                            MJ.CDCLASSFINA = C_CLASS.CDCLASSFINA  AND
                                            MJ.DTMOVFLUXO  = C_DATA.DTDATA   AND
                                            MJ.CDAJUCTREC  = TA.CDAJUCTREC        AND
                                            TA.IDAJUCTREC  = 'A'                  AND
                                            NF.CDFILIAL     = CR.CDFILIAL         AND
                                            NF.NRLANCTONF   = CR.NRLANCTONF       AND
                                            CR.CDFILIBOLREC = BO.CDFILIAL         AND
                                            CR.NRLANBOLREC  = BO.NRLANBOLREC      AND
                                            MJ.CDFILIBOLREC = BO.CDFILIAL         AND
                                            MJ.NRLANBOLREC  = BO.NRLANBOLREC
                                            AND (NOT BO.IDSTATBREC IN ('C', 'B'))
                                            AND (BO.CDCARTCOBBOL IN ('01', '11', '09', '15'))
                                         GROUP BY
                                            NF.CDFILIAL, NF.NRLANCTONF
                                         UNION
                                         SELECT NF.CDFILIAL, NF.NRLANCTONF, ((SUM(CR.VRORIGREC)/SUM(BO.VRBOLREC)) * SUM(MJ.VRFXAJBOLREC)) VRATUAREC
                                         FROM TIPOAJRECEBER TA, MOVFXAJBOLR MJ, NOTAFISCAL NF,
                                              CONTARECEBER CR,  BOLETRECEBER BO
                                         WHERE
                                            MJ.CDEMPRESA   = C_EMP.CDEMPRESA      AND
                                            MJ.CDCLASSFINA = C_CLASS.CDCLASSFINA  AND
                                            MJ.DTMOVFLUXO  = C_DATA.DTDATA   AND
                                            MJ.CDAJUCTREC  = TA.CDAJUCTREC        AND
                                            TA.IDAJUCTREC  = 'D'                  AND
                                            NF.CDFILIAL     = CR.CDFILIAL         AND
                                            NF.NRLANCTONF   = CR.NRLANCTONF       AND
                                            CR.CDFILIBOLREC = BO.CDFILIAL         AND
                                            CR.NRLANBOLREC  = BO.NRLANBOLREC      AND
                                            MJ.CDFILIBOLREC = BO.CDFILIAL         AND
                                            MJ.NRLANBOLREC  = BO.NRLANBOLREC
                                            AND (NOT BO.IDSTATBREC IN ('C', 'B'))
                                            AND (BO.CDCARTCOBBOL IN ('01', '11', '09', '15'))
                                         GROUP BY
                                            NF.CDFILIAL, NF.NRLANCTONF)
                                    GROUP BY CDFILIAL, NRLANCTONF) A,
                                    NOTAFISCAL   NF,
                                    LANCCONT     LCT,
                                    LANCCCUSTO   LCC,
                                    CENTCUST     CTC
                                 WHERE
                                        NF.CDFILIAL    = A.CDFILIAL
                                    AND NF.NRLANCTONF  = A.NRLANCTONF
                                    AND CTC.CDCENTCUST = LCC.CDCENTCUST
                                    AND NF.CDEMPRESA   = LCT.CDEMPRESA
                                    AND NF.NRLANCTBDOC = LCT.NRLANCCONT
                                    AND LCC.CDEMPRESA  = LCT.CDEMPRESA
                                    AND LCC.NRLANCCONT = LCT.NRLANCCONT
                                    AND LCC.NRSEQLANC  = LCT.NRSEQLANC
                                 GROUP BY
                                    LCC.CDFILIAL,
                                    LCC.CDCENTCUST,
                                    CTC.NMCENTCUST) LOOP

               V_CENTCUST := '33'||'03'||C_CENTCUST.CDFILIAL||C_CENTCUST.CDCENTCUST||C_CLASS.CDCLASSFINA;
               SELECT MAX(NRREGIPREV) INTO V_NRREG_MIN
               FROM TRAB_PREV
               WHERE
                  CDFILIPREV = P_CDFILIAL    AND
                  NRPREVISAO = P_NRPREVISAO  AND
                  NRPAGIPREV = V_NRPAGINA    AND
                  DSITEMPREV = V_CENTCUST;

               ALTERA_TRAB_PREV(P_CDFILIAL, P_NRPREVISAO,  LPAD(TO_CHAR(V_NRREG_MIN), 10, '0'),
                                V_NRCOLUNA, C_DATA.DTDATA, C_CENTCUST.TOTALDIA);
            END LOOP;

            /* CONTROLA A COLUNA E A PGINA DO RELATRIO
            V_NRCOLUNA   := V_NRCOLUNA + 1;
            IF V_NRCOLUNA > 6 THEN
               V_NRPAGINA   := V_NRPAGINA + 1;
               V_NRCOLUNA   := 1;
               V_NRREGIENCA := V_NRREGIENCA + 1;
            END IF;
         END LOOP;
         V_NRREGIENCA := V_NRREGIENCA + 1;
      END LOOP;
   END LOOP;


   /*  GRUPO 04
   V_NRREGIENCA := V_NRREGIENCA + 1;
   FOR C_EMP IN C_EMPRESA LOOP
      FOR C_CLASS IN C_CLASSFINANC LOOP
         V_NRCOLUNA   := 1;
         V_NRPAGINA   := 1;
         FOR C_DATA IN C_PERIODO LOOP
            IF (V_NRCOLUNA = 1)  OR (V_NRCOLUNA > 6) THEN
               FOR C_CENTCUST IN (SELECT LCC.CDFILIAL,   LCC.CDCENTCUST,
                                         CTC.NMCENTCUST, SUM(((A.VRATUAREC * LCC.VRLANCCUST) / NF.VRNOTAFISC)) TOTALDIA
                                 FROM
                                    (SELECT CDFILIAL, NRLANCTONF, SUM(VRATUAREC) VRATUAREC
                                     FROM
                                        (SELECT NF.CDFILIAL, NF.NRLANCTONF, SUM(CR.VRATUAREC) VRATUAREC
                                         FROM
                                            NOTAFISCAL   NF, CONTARECEBER CR, BOLETRECEBER BO
                                         WHERE
                                            CR.CDEMPRESA    = C_EMP.CDEMPRESA      AND
                                            CR.CDCLASSFINA  = C_CLASS.CDCLASSFINA  AND
                                            CR.DTMOVFLUXO   BETWEEN P_DTPERIINIC AND P_DTPERIFINA AND
                                            NF.CDFILIAL     = CR.CDFILIAL          AND
                                            NF.NRLANCTONF   = CR.NRLANCTONF        AND
                                            NF.IDSTATUS  IN ('A', 'E')             AND
                                            CR.CDFILIBOLREC = BO.CDFILIAL          AND
                                            CR.NRLANBOLREC  = BO.NRLANBOLREC
                                            AND (NOT CR.IDSTATREC IN ('B', 'C'))
                                            AND (NVL(BO.CDCARTCOBBOL, '1') = '1')
                                         GROUP BY
                                            NF.CDFILIAL, NF.NRLANCTONF
                                         UNION
                                         SELECT NF.CDFILIAL, NF.NRLANCTONF, ((SUM(CR.VRORIGREC)/SUM(BO.VRBOLREC)) * SUM(MJ.VRFXAJBOLREC)) VRATUAREC
                                         FROM TIPOAJRECEBER TA, MOVFXAJBOLR MJ, NOTAFISCAL NF,
                                              CONTARECEBER CR,  BOLETRECEBER BO
                                         WHERE
                                            MJ.CDEMPRESA   = C_EMP.CDEMPRESA      AND
                                            MJ.CDCLASSFINA = C_CLASS.CDCLASSFINA  AND
                                            MJ.DTMOVFLUXO  BETWEEN P_DTPERIINIC AND P_DTPERIFINA AND
                                            MJ.CDAJUCTREC  = TA.CDAJUCTREC        AND
                                            TA.IDAJUCTREC  = 'A'                  AND
                                            NF.CDFILIAL     = CR.CDFILIAL         AND
                                            NF.NRLANCTONF   = CR.NRLANCTONF       AND
                                            CR.CDFILIBOLREC = BO.CDFILIAL         AND
                                            CR.NRLANBOLREC  = BO.NRLANBOLREC      AND
                                            MJ.CDFILIBOLREC = BO.CDFILIAL         AND
                                            MJ.NRLANBOLREC  = BO.NRLANBOLREC
                                            AND (NOT CR.IDSTATREC IN ('B', 'C'))
                                            AND (NVL(BO.CDCARTCOBBOL, '1') = '1')
                                         GROUP BY
                                            NF.CDFILIAL, NF.NRLANCTONF
                                         UNION
                                         SELECT NF.CDFILIAL, NF.NRLANCTONF, ((SUM(CR.VRORIGREC)/SUM(BO.VRBOLREC)) * SUM(MJ.VRFXAJBOLREC)) VRATUAREC
                                         FROM TIPOAJRECEBER TA, MOVFXAJBOLR MJ, NOTAFISCAL NF,
                                              CONTARECEBER CR,  BOLETRECEBER BO
                                         WHERE
                                            MJ.CDEMPRESA   = C_EMP.CDEMPRESA      AND
                                            MJ.CDCLASSFINA = C_CLASS.CDCLASSFINA  AND
                                            MJ.DTMOVFLUXO  BETWEEN P_DTPERIINIC AND P_DTPERIFINA AND
                                            MJ.CDAJUCTREC  = TA.CDAJUCTREC        AND
                                            TA.IDAJUCTREC  = 'D'                  AND
                                            NF.CDFILIAL     = CR.CDFILIAL         AND
                                            NF.NRLANCTONF   = CR.NRLANCTONF       AND
                                            CR.CDFILIBOLREC = BO.CDFILIAL         AND
                                            CR.NRLANBOLREC  = BO.NRLANBOLREC      AND
                                            MJ.CDFILIBOLREC = BO.CDFILIAL         AND
                                            MJ.NRLANBOLREC  = BO.NRLANBOLREC
                                            AND (NOT CR.IDSTATREC IN ('B', 'C'))
                                            AND (NVL(BO.CDCARTCOBBOL, '1') = '1')
                                         GROUP BY
                                            NF.CDFILIAL, NF.NRLANCTONF)
                                    GROUP BY CDFILIAL, NRLANCTONF) A,
                                    NOTAFISCAL   NF,
                                    LANCCONT     LCT,
                                    LANCCCUSTO   LCC,
                                    CENTCUST     CTC
                                 WHERE
                                        NF.CDFILIAL    = A.CDFILIAL
                                    AND NF.NRLANCTONF  = A.NRLANCTONF
                                    AND CTC.CDCENTCUST = LCC.CDCENTCUST
                                    AND NF.CDEMPRESA   = LCT.CDEMPRESA
                                    AND NF.NRLANCTBDOC = LCT.NRLANCCONT
                                    AND LCC.CDEMPRESA  = LCT.CDEMPRESA
                                    AND LCC.NRLANCCONT = LCT.NRLANCCONT
                                    AND LCC.NRSEQLANC  = LCT.NRSEQLANC
                                 GROUP BY
                                    LCC.CDFILIAL,
                                    LCC.CDCENTCUST,
                                    CTC.NMCENTCUST) LOOP

                  V_CENTCUST := '34'||'06'||C_CENTCUST.CDFILIAL||C_CENTCUST.CDCENTCUST||C_CLASS.CDCLASSFINA;
                  INSERT INTO TRAB_PREV(
                     CDFILIPREV,   NRPREVISAO, NRREGIPREV,
                     NRPAGIPREV,   CDGRUPPREV, CDEMPRPREV,
                     CDITEMPREV,   DSITEMPREV, VRATRASOPREV,
                     DTINIPERPREV, DTFINPERPREV)
                  VALUES(
                     P_CDFILIAL,   P_NRPREVISAO,          LPAD(TO_CHAR(V_NRREGIENCA), 10, '0'),
                     V_NRPAGINA,   '34',                  C_EMP.CDEMPRESA,
                     '001', V_CENTCUST,   0,
                     P_DTPERIINIC, P_DTPERIFINA);

                  V_NRREGIENCA := V_NRREGIENCA + 1;
               END LOOP;
               V_NRPAGINA   := V_NRPAGINA + 1;
               V_NRCOLUNA   := 0;
            END IF;
            V_NRCOLUNA   := V_NRCOLUNA + 1;
         END LOOP;

         V_NRPAGINA   := 1;
         V_NRCOLUNA   := 1;
         FOR C_DATA IN C_PERIODO LOOP
               FOR C_CENTCUST IN (SELECT LCC.CDFILIAL,   LCC.CDCENTCUST,
                                         CTC.NMCENTCUST, SUM(((A.VRATUAREC * LCC.VRLANCCUST) / NF.VRNOTAFISC)) TOTALDIA
                                 FROM
                                    (SELECT CDFILIAL, NRLANCTONF, SUM(VRATUAREC) VRATUAREC
                                     FROM
                                        (SELECT NF.CDFILIAL, NF.NRLANCTONF, SUM(CR.VRATUAREC) VRATUAREC
                                         FROM
                                            NOTAFISCAL   NF, CONTARECEBER CR, BOLETRECEBER BO
                                         WHERE
                                            CR.CDEMPRESA    = C_EMP.CDEMPRESA      AND
                                            CR.CDCLASSFINA  = C_CLASS.CDCLASSFINA  AND
                                            CR.DTMOVFLUXO   = C_DATA.DTDATA   AND
                                            NF.CDFILIAL     = CR.CDFILIAL          AND
                                            NF.NRLANCTONF   = CR.NRLANCTONF        AND
                                            NF.IDSTATUS  IN ('A', 'E')             AND
                                            CR.CDFILIBOLREC = BO.CDFILIAL          AND
                                            CR.NRLANBOLREC  = BO.NRLANBOLREC
                                            AND (NOT CR.IDSTATREC IN ('B', 'C'))
                                            AND (NVL(BO.CDCARTCOBBOL, '1') = '1')
                                         GROUP BY
                                            NF.CDFILIAL, NF.NRLANCTONF
                                         UNION
                                         SELECT NF.CDFILIAL, NF.NRLANCTONF, ((SUM(CR.VRORIGREC)/SUM(BO.VRBOLREC)) * SUM(MJ.VRFXAJBOLREC)) VRATUAREC
                                         FROM TIPOAJRECEBER TA, MOVFXAJBOLR MJ, NOTAFISCAL NF,
                                              CONTARECEBER CR,  BOLETRECEBER BO
                                         WHERE
                                            MJ.CDEMPRESA   = C_EMP.CDEMPRESA      AND
                                            MJ.CDCLASSFINA = C_CLASS.CDCLASSFINA  AND
                                            MJ.DTMOVFLUXO  = C_DATA.DTDATA   AND
                                            MJ.CDAJUCTREC  = TA.CDAJUCTREC        AND
                                            TA.IDAJUCTREC  = 'A'                  AND
                                            NF.CDFILIAL     = CR.CDFILIAL         AND
                                            NF.NRLANCTONF   = CR.NRLANCTONF       AND
                                            CR.CDFILIBOLREC = BO.CDFILIAL         AND
                                            CR.NRLANBOLREC  = BO.NRLANBOLREC      AND
                                            MJ.CDFILIBOLREC = BO.CDFILIAL         AND
                                            MJ.NRLANBOLREC  = BO.NRLANBOLREC
                                            AND (NOT CR.IDSTATREC IN ('B', 'C'))
                                            AND (NVL(BO.CDCARTCOBBOL, '1') = '1')
                                         GROUP BY
                                            NF.CDFILIAL, NF.NRLANCTONF
                                         UNION
                                         SELECT NF.CDFILIAL, NF.NRLANCTONF, ((SUM(CR.VRORIGREC)/SUM(BO.VRBOLREC)) * SUM(MJ.VRFXAJBOLREC)) VRATUAREC
                                         FROM TIPOAJRECEBER TA, MOVFXAJBOLR MJ, NOTAFISCAL NF,
                                              CONTARECEBER CR,  BOLETRECEBER BO
                                         WHERE
                                            MJ.CDEMPRESA   = C_EMP.CDEMPRESA      AND
                                            MJ.CDCLASSFINA = C_CLASS.CDCLASSFINA  AND
                                            MJ.DTMOVFLUXO  = C_DATA.DTDATA   AND
                                            MJ.CDAJUCTREC  = TA.CDAJUCTREC        AND
                                            TA.IDAJUCTREC  = 'D'                  AND
                                            NF.CDFILIAL     = CR.CDFILIAL         AND
                                            NF.NRLANCTONF   = CR.NRLANCTONF       AND
                                            CR.CDFILIBOLREC = BO.CDFILIAL         AND
                                            CR.NRLANBOLREC  = BO.NRLANBOLREC      AND
                                            MJ.CDFILIBOLREC = BO.CDFILIAL         AND
                                            MJ.NRLANBOLREC  = BO.NRLANBOLREC
                                            AND (NOT CR.IDSTATREC IN ('B', 'C'))
                                            AND (NVL(BO.CDCARTCOBBOL, '1') = '1')
                                         GROUP BY
                                            NF.CDFILIAL, NF.NRLANCTONF)
                                    GROUP BY CDFILIAL, NRLANCTONF) A,
                                    NOTAFISCAL   NF,
                                    LANCCONT     LCT,
                                    LANCCCUSTO   LCC,
                                    CENTCUST     CTC
                                 WHERE
                                        NF.CDFILIAL    = A.CDFILIAL
                                    AND NF.NRLANCTONF  = A.NRLANCTONF
                                    AND CTC.CDCENTCUST = LCC.CDCENTCUST
                                    AND NF.CDEMPRESA   = LCT.CDEMPRESA
                                    AND NF.NRLANCTBDOC = LCT.NRLANCCONT
                                    AND LCC.CDEMPRESA  = LCT.CDEMPRESA
                                    AND LCC.NRLANCCONT = LCT.NRLANCCONT
                                    AND LCC.NRSEQLANC  = LCT.NRSEQLANC
                                 GROUP BY
                                    LCC.CDFILIAL,
                                    LCC.CDCENTCUST,
                                    CTC.NMCENTCUST) LOOP

               V_CENTCUST := '34'||'06'||C_CENTCUST.CDFILIAL||C_CENTCUST.CDCENTCUST||C_CLASS.CDCLASSFINA;
               SELECT MAX(NRREGIPREV) INTO V_NRREG_MIN
               FROM TRAB_PREV
               WHERE
                  CDFILIPREV = P_CDFILIAL    AND
                  NRPREVISAO = P_NRPREVISAO  AND
                  NRPAGIPREV = V_NRPAGINA    AND
                  DSITEMPREV = V_CENTCUST;

               ALTERA_TRAB_PREV(P_CDFILIAL, P_NRPREVISAO,  LPAD(TO_CHAR(V_NRREG_MIN), 10, '0'),
                                V_NRCOLUNA, C_DATA.DTDATA, C_CENTCUST.TOTALDIA);
            END LOOP;

            /* CONTROLA A COLUNA E A PGINA DO RELATRIO
            V_NRCOLUNA   := V_NRCOLUNA + 1;
            IF V_NRCOLUNA > 6 THEN
               V_NRPAGINA   := V_NRPAGINA + 1;
               V_NRCOLUNA   := 1;
               V_NRREGIENCA := V_NRREGIENCA + 1;
            END IF;
         END LOOP;
         V_NRREGIENCA := V_NRREGIENCA + 1;
      END LOOP;
   END LOOP;


   /*  GRUPO 05
   V_NRREGIENCA := V_NRREGIENCA + 1;
   FOR C_EMP IN C_EMPRESA LOOP
      FOR C_CLASS IN C_CLASSFINANC LOOP
         V_NRCOLUNA   := 1;
         V_NRPAGINA   := 1;
         FOR C_DATA IN C_PERIODO LOOP
            IF (V_NRCOLUNA = 1)  OR (V_NRCOLUNA > 6) THEN
               FOR C_CENTCUST IN (SELECT LCC.CDFILIAL,   LCC.CDCENTCUST,
                                         CTC.NMCENTCUST, SUM(((A.VRATUAREC * LCC.VRLANCCUST) / NF.VRNOTAFISC)) TOTALDIA
                                 FROM
                                    (SELECT CDFILIAL, NRLANCTONF, SUM(VRATUAREC) VRATUAREC
                                     FROM
                                        (SELECT NF.CDFILIAL, NF.NRLANCTONF, SUM(CR.VRATUAREC) VRATUAREC
                                         FROM
                                            NOTAFISCAL   NF, CONTARECEBER CR, BOLETRECEBER BO
                                         WHERE
                                            CR.CDEMPRESA    = C_EMP.CDEMPRESA      AND
                                            CR.CDCLASSFINA  = C_CLASS.CDCLASSFINA  AND
                                            CR.DTMOVFLUXO   BETWEEN P_DTPERIINIC AND P_DTPERIFINA AND
                                            NF.CDFILIAL     = CR.CDFILIAL          AND
                                            NF.NRLANCTONF   = CR.NRLANCTONF        AND
                                            NF.IDSTATUS  IN ('A', 'E')             AND
                                            CR.CDFILIBOLREC = BO.CDFILIAL          AND
                                            CR.NRLANBOLREC  = BO.NRLANBOLREC
                                            AND (BO.IDSTATBREC IN ('B'))
                                            AND (BO.CDCARTCOBBOL IS NULL)
                                         GROUP BY
                                            NF.CDFILIAL, NF.NRLANCTONF
                                         UNION
                                         SELECT NF.CDFILIAL, NF.NRLANCTONF, ((SUM(CR.VRORIGREC)/SUM(BO.VRBOLREC)) * SUM(MJ.VRFXAJBOLREC)) VRATUAREC
                                         FROM TIPOAJRECEBER TA, MOVFXAJBOLR MJ, NOTAFISCAL NF,
                                              CONTARECEBER CR,  BOLETRECEBER BO
                                         WHERE
                                            MJ.CDEMPRESA   = C_EMP.CDEMPRESA      AND
                                            MJ.CDCLASSFINA = C_CLASS.CDCLASSFINA  AND
                                            MJ.DTMOVFLUXO  BETWEEN P_DTPERIINIC AND P_DTPERIFINA AND
                                            MJ.CDAJUCTREC  = TA.CDAJUCTREC        AND
                                            TA.IDAJUCTREC  = 'A'                  AND
                                            NF.CDFILIAL     = CR.CDFILIAL         AND
                                            NF.NRLANCTONF   = CR.NRLANCTONF       AND
                                            CR.CDFILIBOLREC = BO.CDFILIAL         AND
                                            CR.NRLANBOLREC  = BO.NRLANBOLREC      AND
                                            MJ.CDFILIBOLREC = BO.CDFILIAL         AND
                                            MJ.NRLANBOLREC  = BO.NRLANBOLREC
                                            AND (BO.IDSTATBREC IN ('B'))
                                            AND (BO.CDCARTCOBBOL IS NULL)
                                         GROUP BY
                                            NF.CDFILIAL, NF.NRLANCTONF
                                         UNION
                                         SELECT NF.CDFILIAL, NF.NRLANCTONF, ((SUM(CR.VRORIGREC)/SUM(BO.VRBOLREC)) * SUM(MJ.VRFXAJBOLREC)) VRATUAREC
                                         FROM TIPOAJRECEBER TA, MOVFXAJBOLR MJ, NOTAFISCAL NF,
                                              CONTARECEBER CR,  BOLETRECEBER BO
                                         WHERE
                                            MJ.CDEMPRESA   = C_EMP.CDEMPRESA      AND
                                            MJ.CDCLASSFINA = C_CLASS.CDCLASSFINA  AND
                                            MJ.DTMOVFLUXO  BETWEEN P_DTPERIINIC AND P_DTPERIFINA AND
                                            MJ.CDAJUCTREC  = TA.CDAJUCTREC        AND
                                            TA.IDAJUCTREC  = 'D'                  AND
                                            NF.CDFILIAL     = CR.CDFILIAL         AND
                                            NF.NRLANCTONF   = CR.NRLANCTONF       AND
                                            CR.CDFILIBOLREC = BO.CDFILIAL         AND
                                            CR.NRLANBOLREC  = BO.NRLANBOLREC      AND
                                            MJ.CDFILIBOLREC = BO.CDFILIAL         AND
                                            MJ.NRLANBOLREC  = BO.NRLANBOLREC
                                            AND (BO.IDSTATBREC IN ('B'))
                                            AND (BO.CDCARTCOBBOL IS NULL)
                                         GROUP BY
                                            NF.CDFILIAL, NF.NRLANCTONF)
                                    GROUP BY CDFILIAL, NRLANCTONF) A,
                                    NOTAFISCAL   NF,
                                    LANCCONT     LCT,
                                    LANCCCUSTO   LCC,
                                    CENTCUST     CTC
                                 WHERE
                                        NF.CDFILIAL    = A.CDFILIAL
                                    AND NF.NRLANCTONF  = A.NRLANCTONF
                                    AND CTC.CDCENTCUST = LCC.CDCENTCUST
                                    AND NF.CDEMPRESA   = LCT.CDEMPRESA
                                    AND NF.NRLANCTBDOC = LCT.NRLANCCONT
                                    AND LCC.CDEMPRESA  = LCT.CDEMPRESA
                                    AND LCC.NRLANCCONT = LCT.NRLANCCONT
                                    AND LCC.NRSEQLANC  = LCT.NRSEQLANC
                                 GROUP BY
                                    LCC.CDFILIAL,
                                    LCC.CDCENTCUST,
                                    CTC.NMCENTCUST) LOOP

                  V_CENTCUST := '35'||'07'||C_CENTCUST.CDFILIAL||C_CENTCUST.CDCENTCUST||C_CLASS.CDCLASSFINA;
                  INSERT INTO TRAB_PREV(
                     CDFILIPREV,   NRPREVISAO, NRREGIPREV,
                     NRPAGIPREV,   CDGRUPPREV, CDEMPRPREV,
                     CDITEMPREV,   DSITEMPREV, VRATRASOPREV,
                     DTINIPERPREV, DTFINPERPREV)
                  VALUES(
                     P_CDFILIAL,   P_NRPREVISAO,          LPAD(TO_CHAR(V_NRREGIENCA), 10, '0'),
                     V_NRPAGINA,   '35',                  C_EMP.CDEMPRESA,
                     '001', V_CENTCUST,   0,
                     P_DTPERIINIC, P_DTPERIFINA);

                  V_NRREGIENCA := V_NRREGIENCA + 1;
               END LOOP;
               V_NRPAGINA   := V_NRPAGINA + 1;
               V_NRCOLUNA   := 0;
            END IF;
            V_NRCOLUNA   := V_NRCOLUNA + 1;
         END LOOP;

         V_NRPAGINA   := 1;
         V_NRCOLUNA   := 1;
         FOR C_DATA IN C_PERIODO LOOP
               FOR C_CENTCUST IN (SELECT LCC.CDFILIAL,   LCC.CDCENTCUST,
                                         CTC.NMCENTCUST, SUM(((A.VRATUAREC * LCC.VRLANCCUST) / NF.VRNOTAFISC)) TOTALDIA
                                 FROM
                                    (SELECT CDFILIAL, NRLANCTONF, SUM(VRATUAREC) VRATUAREC
                                     FROM
                                        (SELECT NF.CDFILIAL, NF.NRLANCTONF, SUM(CR.VRATUAREC) VRATUAREC
                                         FROM
                                            NOTAFISCAL   NF, CONTARECEBER CR, BOLETRECEBER BO
                                         WHERE
                                            CR.CDEMPRESA    = C_EMP.CDEMPRESA      AND
                                            CR.CDCLASSFINA  = C_CLASS.CDCLASSFINA  AND
                                            CR.DTMOVFLUXO   = C_DATA.DTDATA   AND
                                            NF.CDFILIAL     = CR.CDFILIAL          AND
                                            NF.NRLANCTONF   = CR.NRLANCTONF        AND
                                            NF.IDSTATUS  IN ('A', 'E')             AND
                                            CR.CDFILIBOLREC = BO.CDFILIAL          AND
                                            CR.NRLANBOLREC  = BO.NRLANBOLREC
                                            AND (BO.IDSTATBREC IN ('B'))
                                            AND (BO.CDCARTCOBBOL IS NULL)
                                         GROUP BY
                                            NF.CDFILIAL, NF.NRLANCTONF
                                         UNION
                                         SELECT NF.CDFILIAL, NF.NRLANCTONF, ((SUM(CR.VRORIGREC)/SUM(BO.VRBOLREC)) * SUM(MJ.VRFXAJBOLREC)) VRATUAREC
                                         FROM TIPOAJRECEBER TA, MOVFXAJBOLR MJ, NOTAFISCAL NF,
                                              CONTARECEBER CR,  BOLETRECEBER BO
                                         WHERE
                                            MJ.CDEMPRESA   = C_EMP.CDEMPRESA      AND
                                            MJ.CDCLASSFINA = C_CLASS.CDCLASSFINA  AND
                                            MJ.DTMOVFLUXO  = C_DATA.DTDATA   AND
                                            MJ.CDAJUCTREC  = TA.CDAJUCTREC        AND
                                            TA.IDAJUCTREC  = 'A'                  AND
                                            NF.CDFILIAL     = CR.CDFILIAL         AND
                                            NF.NRLANCTONF   = CR.NRLANCTONF       AND
                                            CR.CDFILIBOLREC = BO.CDFILIAL         AND
                                            CR.NRLANBOLREC  = BO.NRLANBOLREC      AND
                                            MJ.CDFILIBOLREC = BO.CDFILIAL         AND
                                            MJ.NRLANBOLREC  = BO.NRLANBOLREC
                                            AND (BO.IDSTATBREC IN ('B'))
                                            AND (BO.CDCARTCOBBOL IS NULL)
                                         GROUP BY
                                            NF.CDFILIAL, NF.NRLANCTONF
                                         UNION
                                         SELECT NF.CDFILIAL, NF.NRLANCTONF, ((SUM(CR.VRORIGREC)/SUM(BO.VRBOLREC)) * SUM(MJ.VRFXAJBOLREC)) VRATUAREC
                                         FROM TIPOAJRECEBER TA, MOVFXAJBOLR MJ, NOTAFISCAL NF,
                                              CONTARECEBER CR,  BOLETRECEBER BO
                                         WHERE
                                            MJ.CDEMPRESA   = C_EMP.CDEMPRESA      AND
                                            MJ.CDCLASSFINA = C_CLASS.CDCLASSFINA  AND
                                            MJ.DTMOVFLUXO  = C_DATA.DTDATA   AND
                                            MJ.CDAJUCTREC  = TA.CDAJUCTREC        AND
                                            TA.IDAJUCTREC  = 'D'                  AND
                                            NF.CDFILIAL     = CR.CDFILIAL         AND
                                            NF.NRLANCTONF   = CR.NRLANCTONF       AND
                                            CR.CDFILIBOLREC = BO.CDFILIAL         AND
                                            CR.NRLANBOLREC  = BO.NRLANBOLREC      AND
                                            MJ.CDFILIBOLREC = BO.CDFILIAL         AND
                                            MJ.NRLANBOLREC  = BO.NRLANBOLREC
                                            AND (BO.IDSTATBREC IN ('B'))
                                            AND (BO.CDCARTCOBBOL IS NULL)
                                         GROUP BY
                                            NF.CDFILIAL, NF.NRLANCTONF)
                                    GROUP BY CDFILIAL, NRLANCTONF) A,
                                    NOTAFISCAL   NF,
                                    LANCCONT     LCT,
                                    LANCCCUSTO   LCC,
                                    CENTCUST     CTC
                                 WHERE
                                        NF.CDFILIAL    = A.CDFILIAL
                                    AND NF.NRLANCTONF  = A.NRLANCTONF
                                    AND CTC.CDCENTCUST = LCC.CDCENTCUST
                                    AND NF.CDEMPRESA   = LCT.CDEMPRESA
                                    AND NF.NRLANCTBDOC = LCT.NRLANCCONT
                                    AND LCC.CDEMPRESA  = LCT.CDEMPRESA
                                    AND LCC.NRLANCCONT = LCT.NRLANCCONT
                                    AND LCC.NRSEQLANC  = LCT.NRSEQLANC
                                 GROUP BY
                                    LCC.CDFILIAL,
                                    LCC.CDCENTCUST,
                                    CTC.NMCENTCUST) LOOP

               V_CENTCUST := '35'||'07'||C_CENTCUST.CDFILIAL||C_CENTCUST.CDCENTCUST||C_CLASS.CDCLASSFINA;
               SELECT MAX(NRREGIPREV) INTO V_NRREG_MIN
               FROM TRAB_PREV
               WHERE
                  CDFILIPREV = P_CDFILIAL    AND
                  NRPREVISAO = P_NRPREVISAO  AND
                  NRPAGIPREV = V_NRPAGINA    AND
                  DSITEMPREV = V_CENTCUST;

               ALTERA_TRAB_PREV(P_CDFILIAL, P_NRPREVISAO,  LPAD(TO_CHAR(V_NRREG_MIN), 10, '0'),
                                V_NRCOLUNA, C_DATA.DTDATA, C_CENTCUST.TOTALDIA);
            END LOOP;

            /* CONTROLA A COLUNA E A PGINA DO RELATRIO
            V_NRCOLUNA   := V_NRCOLUNA + 1;
            IF V_NRCOLUNA > 6 THEN
               V_NRPAGINA   := V_NRPAGINA + 1;
               V_NRCOLUNA   := 1;
               V_NRREGIENCA := V_NRREGIENCA + 1;
            END IF;
         END LOOP;
         V_NRREGIENCA := V_NRREGIENCA + 1;
      END LOOP;
   END LOOP;

   /*  GRUPO 06
   V_NRREGIENCA := V_NRREGIENCA + 1;
   FOR C_EMP IN C_EMPRESA LOOP
      FOR C_CLASS IN C_CLASSFINANC LOOP
         V_NRCOLUNA   := 1;
         V_NRPAGINA   := 1;

         SELECT COUNT(*) INTO V_CTCONTA
         FROM MOVCREDBANC
         WHERE
            CDTPCREDBANC <> '04' AND
            DTMOVICRED BETWEEN P_DTPERIINIC AND P_DTPERIFINA AND
            CDCLASSFINA = C_CLASS.CDCLASSFINA AND
            CDEMPRESA   = C_EMP.CDEMPRESA;

         IF  V_CTCONTA > 0 THEN
            FOR C_DATA IN C_PERIODO LOOP
               IF (V_NRCOLUNA = 1)  OR (V_NRCOLUNA > 6) THEN
                  FOR C_CENTCUST IN (SELECT LCC.CDFILIAL,   LCC.CDCENTCUST,
                                            CTC.NMCENTCUST, SUM(LCC.VRLANCCUST) TOTALDIA
                                     FROM
                                        MOVCREDBANC MOV,
                                        LANCCONT    LCT,
                                        LANCCCUSTO  LCC,
                                        CENTCUST    CTC
                                     WHERE
                                        CDTPCREDBANC <> '04' AND
                                        CTC.CDCENTCUST   = LCC.CDCENTCUST  AND
                                         MOV.DTMOVICRED BETWEEN P_DTPERIINIC AND P_DTPERIFINA AND
                                        MOV.CDCLASSFINA = C_CLASS.CDCLASSFINA AND
                                        MOV.CDEMPRESA   = C_EMP.CDEMPRESA     AND
                                        MOV.CDECTBMCRED = LCT.CDEMPRESA       AND
                                        MOV.NRLCTBMCRED = LCT.NRLANCCONT      AND
                                        LCC.CDEMPRESA   = LCT.CDEMPRESA       AND
                                        LCC.NRLANCCONT  = LCT.NRLANCCONT      AND
                                        LCC.NRSEQLANC   = LCT.NRSEQLANC
                                     GROUP BY
                                        LCC.CDFILIAL,
                                        LCC.CDCENTCUST,
                                        CTC.NMCENTCUST) LOOP

                     V_CENTCUST := '36'||'06'||C_CENTCUST.CDFILIAL||C_CENTCUST.CDCENTCUST||C_CLASS.CDCLASSFINA;
                     INSERT INTO TRAB_PREV(
                        CDFILIPREV,   NRPREVISAO, NRREGIPREV,
                        NRPAGIPREV,   CDGRUPPREV, CDEMPRPREV,
                        CDITEMPREV,   DSITEMPREV, VRATRASOPREV,
                        DTINIPERPREV, DTFINPERPREV)
                     VALUES(
                        P_CDFILIAL,   P_NRPREVISAO,          LPAD(TO_CHAR(V_NRREGIENCA), 10, '0'),
                        V_NRPAGINA,   '36',                  C_EMP.CDEMPRESA,
                        '002', V_CENTCUST,   0,
                        P_DTPERIINIC, P_DTPERIFINA);

                     V_NRREGIENCA := V_NRREGIENCA + 1;
                  END LOOP;
                  V_NRPAGINA   := V_NRPAGINA + 1;
                  V_NRCOLUNA   := 0;
               END IF;
               V_NRCOLUNA   := V_NRCOLUNA + 1;
            END LOOP;

            V_NRPAGINA   := 1;
            V_NRCOLUNA   := 1;
            FOR C_DATA IN C_PERIODO LOOP
               FOR C_CENTCUST IN (SELECT LCC.CDFILIAL,   LCC.CDCENTCUST,
                                         CTC.NMCENTCUST, SUM(LCC.VRLANCCUST) TOTALDIA
                                  FROM
                                     MOVCREDBANC MOV,
                                     LANCCONT    LCT,
                                     LANCCCUSTO  LCC,
                                     CENTCUST    CTC
                                  WHERE
                                     CDTPCREDBANC <> '04' AND
                                     CTC.CDCENTCUST  = LCC.CDCENTCUST  AND
                                     MOV.DTMOVICRED  = C_DATA.DTDATA   AND
                                     MOV.CDCLASSFINA = C_CLASS.CDCLASSFINA AND
                                     MOV.CDEMPRESA   = C_EMP.CDEMPRESA     AND
                                     MOV.CDECTBMCRED = LCT.CDEMPRESA       AND
                                     MOV.NRLCTBMCRED = LCT.NRLANCCONT      AND
                                     LCC.CDEMPRESA   = LCT.CDEMPRESA       AND
                                     LCC.NRLANCCONT  = LCT.NRLANCCONT      AND
                                     LCC.NRSEQLANC   = LCT.NRSEQLANC
                                  GROUP BY
                                     LCC.CDFILIAL,
                                     LCC.CDCENTCUST,
                                     CTC.NMCENTCUST) LOOP

                  V_CENTCUST := '36'||'06'||C_CENTCUST.CDFILIAL||C_CENTCUST.CDCENTCUST||C_CLASS.CDCLASSFINA;
                  SELECT MAX(NRREGIPREV) INTO V_NRREG_MIN
                  FROM TRAB_PREV
                  WHERE
                     CDFILIPREV = P_CDFILIAL    AND
                     NRPREVISAO = P_NRPREVISAO  AND
                     NRPAGIPREV = V_NRPAGINA    AND
                     DSITEMPREV = V_CENTCUST;

                  ALTERA_TRAB_PREV(P_CDFILIAL, P_NRPREVISAO,  LPAD(TO_CHAR(V_NRREG_MIN), 10, '0'),
                                   V_NRCOLUNA, C_DATA.DTDATA, C_CENTCUST.TOTALDIA);
               END LOOP;

               /* CONTROLA A COLUNA E A PGINA DO RELATRIO
               V_NRCOLUNA   := V_NRCOLUNA + 1;
               IF V_NRCOLUNA > 6 THEN
                  V_NRPAGINA   := V_NRPAGINA + 1;
                  V_NRCOLUNA   := 1;
                  V_NRREGIENCA := V_NRREGIENCA + 1;
               END IF;
            END LOOP;
            V_NRREGIENCA := V_NRREGIENCA + 1;
         END IF;
      END LOOP;
   END LOOP;


   /*  GRUPO 20 */
   V_NRREGIENCA := V_NRREGIENCA + 1;
   FOR C_EMP IN C_EMPRESA LOOP
      FOR C_CLASS IN C_CLASSFINANC LOOP
         V_NRCOLUNA   := 1;
         V_NRPAGINA   := 1;

         FOR C_DATA IN C_PERIODO LOOP
            IF (V_NRCOLUNA = 1)  THEN
               FOR C_CENTCUST IN (SELECT LCC.CDFILIAL,   LCC.CDCENTCUST,
                                         CTC.NMCENTCUST, SUM(((A.VRATUAPAG * LCC.VRLANCCUST) / NF.VRNOTAFISC)) TOTALDIA
                                 FROM
                                    (SELECT CDFILIAL, NRLANCTONF, SUM(VRATUAPAG) VRATUAPAG
                                     FROM
                                        (SELECT NF.CDFILIAL, NF.NRLANCTONF, SUM(CP.VRATUAPAG) VRATUAPAG
                                         FROM
                                            NOTAFISCAL   NF, CONTAPAGAR CP, BOLETPAGAR BO
                                         WHERE
                                            CP.CDEMPRESA    = C_EMP.CDEMPRESA      AND
                                            CP.CDCLASSFINA  = C_CLASS.CDCLASSFINA  AND
                                            CP.DTMOVFLUXO   BETWEEN P_DTPERIINIC AND P_DTPERIFINA AND
                                            NF.CDFILIAL     = CP.CDFILIAL          AND
                                            NF.NRLANCTONF   = CP.NRLANCTONF        AND
                                            NF.IDSTATUS  IN ('A', 'E')             AND
                                            CP.CDFILIBPAG = BO.CDFILIAL            AND
                                            CP.NRLANBOLPAG  = BO.NRLANBOLPAG       AND
                                            NOT CP.IDSTATPAG IN ('B', 'C')
                                         GROUP BY
                                            NF.CDFILIAL, NF.NRLANCTONF
                                         UNION
                                         SELECT NF.CDFILIAL, NF.NRLANCTONF, ((SUM(CP.VRORIGPAG)/SUM(BO.VRBOLPAG)) * SUM(MJ.VRFXAJBOLPAG)) VRATUAPAG
                                         FROM TIPOAJPAGAR TA, MOVFXAJBOLP MJ, NOTAFISCAL NF,
                                              CONTAPAGAR CP,  BOLETPAGAR BO
                                         WHERE
                                            MJ.CDEMPRESA   = C_EMP.CDEMPRESA      AND
                                            MJ.CDCLASSFINA = C_CLASS.CDCLASSFINA  AND
                                            MJ.DTMOVFLUXO  BETWEEN P_DTPERIINIC AND P_DTPERIFINA AND
                                            MJ.CDAJUCTPAG  = TA.CDAJUCTPAG        AND
                                            TA.IDAJUCTPAG  = 'A'                  AND
                                            NF.CDFILIAL     = CP.CDFILIAL         AND
                                            NF.NRLANCTONF   = CP.NRLANCTONF       AND
                                            CP.CDFILIBPAG = BO.CDFILIAL         AND
                                            CP.NRLANBOLPAG  = BO.NRLANBOLPAG      AND
                                            MJ.CDFILIBOLPAG = BO.CDFILIAL         AND
                                            MJ.NRLANBOLPAG  = BO.NRLANBOLPAG      AND
                                            NOT CP.IDSTATPAG IN ('B', 'C')
                                         GROUP BY
                                            NF.CDFILIAL, NF.NRLANCTONF
                                         UNION
                                         SELECT NF.CDFILIAL, NF.NRLANCTONF, ((SUM(CP.VRORIGPAG)/SUM(BO.VRBOLPAG)) * SUM(MJ.VRFXAJBOLPAG)) VRATUAPAG
                                         FROM TIPOAJPAGAR TA, MOVFXAJBOLP MJ, NOTAFISCAL NF,
                                              CONTAPAGAR CP,  BOLETPAGAR BO
                                         WHERE
                                            MJ.CDEMPRESA   = C_EMP.CDEMPRESA      AND
                                            MJ.CDCLASSFINA = C_CLASS.CDCLASSFINA  AND
                                            MJ.DTMOVFLUXO  BETWEEN P_DTPERIINIC AND P_DTPERIFINA AND
                                            MJ.CDAJUCTPAG  = TA.CDAJUCTPAG        AND
                                            TA.IDAJUCTPAG  = 'D'                  AND
                                            NF.CDFILIAL     = CP.CDFILIAL         AND
                                            NF.NRLANCTONF   = CP.NRLANCTONF       AND
                                            CP.CDFILIBPAG = BO.CDFILIAL         AND
                                            CP.NRLANBOLPAG  = BO.NRLANBOLPAG      AND
                                            MJ.CDFILIBOLPAG = BO.CDFILIAL         AND
                                            MJ.NRLANBOLPAG  = BO.NRLANBOLPAG      AND
                                            NOT CP.IDSTATPAG IN ('B', 'C')
                                         GROUP BY
                                            NF.CDFILIAL, NF.NRLANCTONF)
                                    GROUP BY CDFILIAL, NRLANCTONF) A,
                                    NOTAFISCAL   NF,
                                    LANCCONT     LCT,
                                    LANCCCUSTO   LCC,
                                    CENTCUST     CTC
                                 WHERE
                                        NF.CDFILIAL    = A.CDFILIAL
                                    AND NF.NRLANCTONF  = A.NRLANCTONF
                                    AND CTC.CDCENTCUST = LCC.CDCENTCUST
                                    AND NF.CDEMPRESA   = LCT.CDEMPRESA
                                    AND NF.NRLANCTBDOC = LCT.NRLANCCONT
                                    AND LCC.CDEMPRESA  = LCT.CDEMPRESA
                                    AND LCC.NRLANCCONT = LCT.NRLANCCONT
                                    AND LCC.NRSEQLANC  = LCT.NRSEQLANC
                                 GROUP BY
                                    LCC.CDFILIAL,
                                    LCC.CDCENTCUST,
                                    CTC.NMCENTCUST) LOOP

                  V_CENTCUST := '50'||'20'||C_CENTCUST.CDFILIAL||C_CENTCUST.CDCENTCUST||C_CLASS.CDCLASSFINA;
                  INSERT INTO TRAB_PREV(
                     CDFILIPREV,   NRPREVISAO, NRREGIPREV,
                     NRPAGIPREV,   CDGRUPPREV, CDEMPRPREV,
                     CDITEMPREV,   DSITEMPREV, VRATRASOPREV,
                     DTINIPERPREV, DTFINPERPREV)
                  VALUES(
                     P_CDFILIAL,   P_NRPREVISAO,          LPAD(TO_CHAR(V_NRREGIENCA), 10, '0'),
                     V_NRPAGINA,   '50',                  C_EMP.CDEMPRESA,
                     '001', V_CENTCUST,   0,
                     P_DTPERIINIC, P_DTPERIFINA);

                  V_NRREGIENCA := V_NRREGIENCA + 1;
               END LOOP;
            END IF;
            V_NRCOLUNA   := V_NRCOLUNA + 1;
            IF V_NRCOLUNA > 6 THEN
               V_NRPAGINA   := V_NRPAGINA + 1;
               V_NRCOLUNA   := 1;
            END IF;
         END LOOP;

         V_NRPAGINA   := 1;
         V_NRCOLUNA   := 1;
         FOR C_DATA IN C_PERIODO LOOP
               FOR C_CENTCUST IN (SELECT LCC.CDFILIAL,   LCC.CDCENTCUST,
                                         CTC.NMCENTCUST, SUM(((A.VRATUAPAG * LCC.VRLANCCUST) / NF.VRNOTAFISC)) TOTALDIA
                                 FROM
                                    (SELECT CDFILIAL, NRLANCTONF, SUM(VRATUAPAG) VRATUAPAG
                                     FROM
                                        (SELECT NF.CDFILIAL, NF.NRLANCTONF, SUM(CP.VRATUAPAG) VRATUAPAG
                                         FROM
                                            NOTAFISCAL   NF, CONTAPAGAR CP, BOLETPAGAR BO
                                         WHERE
                                            CP.CDEMPRESA    = C_EMP.CDEMPRESA      AND
                                            CP.CDCLASSFINA  = C_CLASS.CDCLASSFINA  AND
                                            CP.DTMOVFLUXO   = C_DATA.DTDATA   AND
                                            NF.CDFILIAL     = CP.CDFILIAL          AND
                                            NF.NRLANCTONF   = CP.NRLANCTONF        AND
                                            NF.IDSTATUS  IN ('A', 'E')             AND
                                            CP.CDFILIBPAG = BO.CDFILIAL          AND
                                            CP.NRLANBOLPAG  = BO.NRLANBOLPAG     AND
                                            NOT CP.IDSTATPAG IN ('B', 'C')
                                         GROUP BY
                                            NF.CDFILIAL, NF.NRLANCTONF
                                         UNION
                                         SELECT NF.CDFILIAL, NF.NRLANCTONF, ((SUM(CP.VRORIGPAG)/SUM(BO.VRBOLPAG)) * SUM(MJ.VRFXAJBOLPAG)) VRATUAPAG
                                         FROM TIPOAJPAGAR TA, MOVFXAJBOLP MJ, NOTAFISCAL NF,
                                              CONTAPAGAR CP,  BOLETPAGAR BO
                                         WHERE
                                            MJ.CDEMPRESA   = C_EMP.CDEMPRESA      AND
                                            MJ.CDCLASSFINA = C_CLASS.CDCLASSFINA  AND
                                            MJ.DTMOVFLUXO  = C_DATA.DTDATA   AND
                                            MJ.CDAJUCTPAG  = TA.CDAJUCTPAG        AND
                                            TA.IDAJUCTPAG  = 'A'                  AND
                                            NF.CDFILIAL     = CP.CDFILIAL         AND
                                            NF.NRLANCTONF   = CP.NRLANCTONF       AND
                                            CP.CDFILIBPAG = BO.CDFILIAL         AND
                                            CP.NRLANBOLPAG  = BO.NRLANBOLPAG      AND
                                            MJ.CDFILIBOLPAG = BO.CDFILIAL         AND
                                            MJ.NRLANBOLPAG  = BO.NRLANBOLPAG      AND
                                            NOT CP.IDSTATPAG IN ('B', 'C')
                                         GROUP BY
                                            NF.CDFILIAL, NF.NRLANCTONF
                                         UNION
                                         SELECT NF.CDFILIAL, NF.NRLANCTONF, ((SUM(CP.VRORIGPAG)/SUM(BO.VRBOLPAG)) * SUM(MJ.VRFXAJBOLPAG)) VRATUAPAG
                                         FROM TIPOAJPAGAR TA, MOVFXAJBOLP MJ, NOTAFISCAL NF,
                                              CONTAPAGAR CP,  BOLETPAGAR BO
                                         WHERE
                                            MJ.CDEMPRESA   = C_EMP.CDEMPRESA      AND
                                            MJ.CDCLASSFINA = C_CLASS.CDCLASSFINA  AND
                                            MJ.DTMOVFLUXO  = C_DATA.DTDATA   AND
                                            MJ.CDAJUCTPAG  = TA.CDAJUCTPAG        AND
                                            TA.IDAJUCTPAG  = 'D'                  AND
                                            NF.CDFILIAL     = CP.CDFILIAL         AND
                                            NF.NRLANCTONF   = CP.NRLANCTONF       AND
                                            CP.CDFILIBPAG = BO.CDFILIAL         AND
                                            CP.NRLANBOLPAG  = BO.NRLANBOLPAG      AND
                                            MJ.CDFILIBOLPAG = BO.CDFILIAL         AND
                                            MJ.NRLANBOLPAG  = BO.NRLANBOLPAG      AND
                                            NOT CP.IDSTATPAG IN ('B', 'C')
                                         GROUP BY
                                            NF.CDFILIAL, NF.NRLANCTONF)
                                    GROUP BY CDFILIAL, NRLANCTONF) A,
                                    NOTAFISCAL   NF,
                                    LANCCONT     LCT,
                                    LANCCCUSTO   LCC,
                                    CENTCUST     CTC
                                 WHERE
                                        NF.CDFILIAL    = A.CDFILIAL
                                    AND NF.NRLANCTONF  = A.NRLANCTONF
                                    AND CTC.CDCENTCUST = LCC.CDCENTCUST
                                    AND NF.CDEMPRESA   = LCT.CDEMPRESA
                                    AND NF.NRLANCTBDOC = LCT.NRLANCCONT
                                    AND LCC.CDEMPRESA  = LCT.CDEMPRESA
                                    AND LCC.NRLANCCONT = LCT.NRLANCCONT
                                    AND LCC.NRSEQLANC  = LCT.NRSEQLANC
                                 GROUP BY
                                    LCC.CDFILIAL,
                                    LCC.CDCENTCUST,
                                    CTC.NMCENTCUST) LOOP

               V_CENTCUST := '50'||'20'||C_CENTCUST.CDFILIAL||C_CENTCUST.CDCENTCUST||C_CLASS.CDCLASSFINA;
               SELECT MAX(NRREGIPREV) INTO V_NRREG_MIN
               FROM TRAB_PREV
               WHERE
                  CDFILIPREV = P_CDFILIAL    AND
                  NRPREVISAO = P_NRPREVISAO  AND
                  NRPAGIPREV = V_NRPAGINA    AND
                  DSITEMPREV = V_CENTCUST;

               ALTERA_TRAB_PREV(P_CDFILIAL, P_NRPREVISAO,  LPAD(TO_CHAR(V_NRREG_MIN), 10, '0'),
                                V_NRCOLUNA, C_DATA.DTDATA, C_CENTCUST.TOTALDIA);
            END LOOP;

            /* CONTROLA A COLUNA E A PGINA DO RELATRIO */
            V_NRCOLUNA   := V_NRCOLUNA + 1;
            IF V_NRCOLUNA > 6 THEN
               V_NRPAGINA   := V_NRPAGINA + 1;
               V_NRCOLUNA   := 1;
               V_NRREGIENCA := V_NRREGIENCA + 1;
            END IF;
         END LOOP;

         V_NRREGIENCA := V_NRREGIENCA + 1;
      END LOOP;
   END LOOP;

   /*  GRUPO 23 */
   V_NRREGIENCA := V_NRREGIENCA + 1;
   FOR C_EMP IN C_EMPRESA LOOP
      FOR C_CLASS IN C_CLASSFINANC LOOP
         V_NRCOLUNA   := 1;
         V_NRPAGINA   := 1;
         FOR C_DATA IN C_PERIODO LOOP
            IF (V_NRCOLUNA = 1)  /* OR (V_NRCOLUNA > 6) */ THEN
               FOR C_CENTCUST IN (SELECT LCC.CDFILIAL,   LCC.CDCENTCUST,
                                         CTC.NMCENTCUST, SUM(LCC.VRLANCCUST) TOTALDIA
                                  FROM
                                     MOVDEBBANC MOV,
                                     LANCCONT    LCT,
                                     LANCCCUSTO  LCC,
                                     CENTCUST    CTC
                                  WHERE
                                     CTC.CDCENTCUST   = LCC.CDCENTCUST  AND
                                     MOV.DTMOVIDEBI BETWEEN P_DTPERIINIC  AND P_DTPERIFINA AND
                                     MOV.CDCLASSFINA = C_CLASS.CDCLASSFINA AND
                                     MOV.CDEMPRESA   = C_EMP.CDEMPRESA     AND
                                     MOV.CDECTBMDEB = LCT.CDEMPRESA        AND
                                     MOV.NRLCTBMDEB = LCT.NRLANCCONT       AND
                                     LCC.CDEMPRESA   = LCT.CDEMPRESA       AND
                                     LCC.NRLANCCONT  = LCT.NRLANCCONT      AND
                                     LCC.NRSEQLANC   = LCT.NRSEQLANC
                                  GROUP BY
                                     LCC.CDFILIAL,
                                     LCC.CDCENTCUST,
                                     CTC.NMCENTCUST) LOOP

                  V_CENTCUST := '50'||'23'||C_CENTCUST.CDFILIAL||C_CENTCUST.CDCENTCUST||C_CLASS.CDCLASSFINA;
                  INSERT INTO TRAB_PREV(
                     CDFILIPREV,   NRPREVISAO, NRREGIPREV,
                     NRPAGIPREV,   CDGRUPPREV, CDEMPRPREV,
                     CDITEMPREV,   DSITEMPREV, VRATRASOPREV,
                     DTINIPERPREV, DTFINPERPREV)
                  VALUES(
                     P_CDFILIAL,   P_NRPREVISAO,          LPAD(TO_CHAR(V_NRREGIENCA), 10, '0'),
                     V_NRPAGINA,   '50',                  C_EMP.CDEMPRESA,
                     '001', V_CENTCUST,   0,
                     P_DTPERIINIC, P_DTPERIFINA);

                  V_NRREGIENCA := V_NRREGIENCA + 1;
               END LOOP;
            END IF;
            V_NRCOLUNA   := V_NRCOLUNA + 1;
            IF V_NRCOLUNA > 6 THEN
               V_NRPAGINA   := V_NRPAGINA + 1;
               V_NRCOLUNA   := 1;
            END IF;
         END LOOP;

         V_NRPAGINA   := 1;
         V_NRCOLUNA   := 1;
         FOR C_DATA IN C_PERIODO LOOP
            FOR C_CENTCUST IN (SELECT LCC.CDFILIAL,   LCC.CDCENTCUST,
                                      CTC.NMCENTCUST, SUM(LCC.VRLANCCUST) TOTALDIA
                               FROM
                                  MOVDEBBANC MOV,
                                  LANCCONT    LCT,
                                  LANCCCUSTO  LCC,
                                  CENTCUST    CTC
                               WHERE
                                  CTC.CDCENTCUST  = LCC.CDCENTCUST  AND
                                  MOV.DTMOVIDEBI  = C_DATA.DTDATA   AND
                                  MOV.CDCLASSFINA = C_CLASS.CDCLASSFINA AND
                                  MOV.CDEMPRESA   = C_EMP.CDEMPRESA     AND
                                  MOV.CDECTBMDEB = LCT.CDEMPRESA        AND
                                  MOV.NRLCTBMDEB = LCT.NRLANCCONT       AND
                                  LCC.CDEMPRESA   = LCT.CDEMPRESA       AND
                                  LCC.NRLANCCONT  = LCT.NRLANCCONT      AND
                                  LCC.NRSEQLANC   = LCT.NRSEQLANC
                               GROUP BY
                                  LCC.CDFILIAL,
                                  LCC.CDCENTCUST,
                                  CTC.NMCENTCUST) LOOP

               V_CENTCUST := '50'||'23'||C_CENTCUST.CDFILIAL||C_CENTCUST.CDCENTCUST||C_CLASS.CDCLASSFINA;
               SELECT MAX(NRREGIPREV) INTO V_NRREG_MIN
               FROM TRAB_PREV
               WHERE
                  CDFILIPREV = P_CDFILIAL    AND
                  NRPREVISAO = P_NRPREVISAO  AND
                  NRPAGIPREV = V_NRPAGINA    AND
                  DSITEMPREV = V_CENTCUST;

               ALTERA_TRAB_PREV(P_CDFILIAL, P_NRPREVISAO,  LPAD(TO_CHAR(V_NRREG_MIN), 10, '0'),
                                V_NRCOLUNA, C_DATA.DTDATA, C_CENTCUST.TOTALDIA);
            END LOOP;

            /* CONTROLA A COLUNA E A PGINA DO RELATRIO  */
            V_NRCOLUNA   := V_NRCOLUNA + 1;
            IF V_NRCOLUNA > 6 THEN
               V_NRPAGINA   := V_NRPAGINA + 1;
               V_NRCOLUNA   := 1;
            END IF;
         END LOOP;
      END LOOP;
   END LOOP;

END;
/
